SystemOrganization addCategory: #'Tweak-ProjectBuilder'!
SystemOrganization addCategory: #'Tweak-ProjectBuilder-Costumes'!

CPlayer subclass: #CLibraryEntryCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder-Costumes'!

CLibraryEntryCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="image" toSet="image:" changeEvent="imageChanged">image</field>
</fields>'!

!CLibraryEntryCostume methodsFor: 'events' stamp: 'ar 2/24/2004 23:02'!
deselect
	self color: Color transparent.! !

!CLibraryEntryCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:25'!
image
	"Answer the image of the receiver"
	<bewareOf: #imageChanged>
	^self propertyValueAt: #image! !

!CLibraryEntryCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:25'!
image: aValue
	"Modify the receiver's image"
	^self propertyValueAt: #image put: aValue with: #imageChanged! !

!CLibraryEntryCostume methodsFor: 'initialize' stamp: 'ar 3/22/2004 14:40'!
initialize
	super initialize.
	self define: #label as: CLabel new.
	self define: #image as: CPlayer new.
! !

!CLibraryEntryCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:25'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CLibraryEntryCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:25'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CLibraryEntryCostume methodsFor: 'events' stamp: 'ar 3/1/2005 09:36'!
onDragStart
	| aPlayer event newGuy target |
	<on: mouseDrag>
	self value ifNil:[^self].
	aPlayer := CPlayer new.
	aPlayer extent: self value image extent.
	aPlayer color: Color transparent.
	aPlayer graphic: self value image.
	aPlayer value: self value value. "the maker"
	self hand attach: aPlayer.
	aPlayer center: self hand position.
	"Okay, this looks wrong - see comment in Object>>waitUntil:..."
	event := aPlayer waitUntil: #dropAccept.
	target := event arguments first.
	newGuy := self value next asPlayer.
	newGuy topLeft: aPlayer topLeft.
	target elements replace: aPlayer with: newGuy.! !

!CLibraryEntryCostume methodsFor: 'events' stamp: 'ar 3/6/2004 15:58'!
onValueChanged
	<on: valueChanged>
	image graphic: self value image.
	label value: self value label.
! !

!CLibraryEntryCostume methodsFor: 'events' stamp: 'ar 2/24/2004 23:04'!
select
	self color: (Color r: 1 g: 0.7 b: 0.15).! !

!CLibraryEntryCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:58'!
setupCostume
	self layout: CTableLayout new.
	self add: label.
	self add: image.
	image graphic: CCostumeGraphic new.
	image graphicFit: #scale.
	self borderStyle: #simple; borderWidth: 1; borderColor: Color black.
	self roundCorners: true.
	self extent: 64@64.! !

CPlayer subclass: #CProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder'!

CProject defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="library" toSet="library:" changeEvent="libraryChanged">library</field>
	<field toGet="thumbnail" toSet="thumbnail:" changeEvent="thumbnailChanged">thumbnail</field>
</fields>'!

!CProject methodsFor: 'initialize' stamp: 'ar 3/5/2004 14:45'!
destroy
	"Destroy this project"
	self name: '<destroyed project>'.
	self thumbnail: nil.
	super destroy.! !

!CProject methodsFor: 'initialize' stamp: 'ar 3/25/2004 19:23'!
initialize
	super initialize.
	self name: nil.
	self define: #library as: CProjectLibrary new.
	self clipping: true.! !

!CProject methodsFor: 'field access' stamp: 'ar 3/17/2004 15:12'!
library
	"This method was automatically generated"
	<bewareOf: #libraryChanged>
	^self propertyValueAt: #library! !

!CProject methodsFor: 'field access' stamp: 'ar 3/11/2004 14:24'!
library: aValue
	"This method was automatically generated"
	^self propertyValueAt: #library put: aValue with: #libraryChanged! !

!CProject methodsFor: 'actions' stamp: 'tk 7/14/2004 11:27'!
makeThumbnail
	"Create a new thumbnail"
	self thumbnail: (self asPrimCostume asFormExtent: 128@128).! !

!CProject methodsFor: 'layout' stamp: 'tk 6/25/2004 22:43'!
okToPlace: aPlayer at: pt
	"Return true if no obvious intersection of aPlayer with other existing players is placed at the point"

	| rr |
	rr := aPlayer bounds.
		"Transcript show: rr extent; cr."
	rr := pt extent: rr extent.
	elements do: [:obj |
		(obj globalBounds intersects: rr) ifTrue: [^ false]].
	^ true! !

!CProject methodsFor: 'layout' stamp: 'tk 6/25/2004 22:38'!
positionToOpen: aPlayer
	"Look for a place to open this player.  If a TileViewer, really want to know its target.  Maybe find out how has a halo."

	| rect pt2 |
	rect := self globalBounds.
	rect := rect origin copy extent: (rect extent - aPlayer extent max: (0@0)).	"places to put upper left corner"
	{0.2@0.2. 0.98@0.98. 0.4@0. 0@0.4. 0.5@0.5. 1.0@0.5. 0.5@1.0. 0.75@0.75. 1.0@0. 0@1.0} do: [:pt |
		pt2 := (rect origin + (pt * rect extent)) truncated.
		(self okToPlace: aPlayer at: pt2) ifTrue: [^ pt2]].

	^ self hand position - 100
! !

!CProject methodsFor: 'field access' stamp: 'tk 8/9/2004 18:00'!
project
	^ self! !

!CProject methodsFor: 'accessing' stamp: 'ar 3/5/2004 14:50'!
root
	^self! !

!CProject methodsFor: 'initialize' stamp: 'tk 4/28/2005 14:05'!
setupCostume
	super setupCostume.
	self asPrimCostume indicatePenTrails: true.	"default place for any object to draw with its pen"! !

!CProject methodsFor: 'field access' stamp: 'ar 3/17/2004 15:13'!
thumbnail
	"This method was automatically generated"
	<bewareOf: #thumbnailChanged>
	^self propertyValueAt: #thumbnail! !

!CProject methodsFor: 'field access' stamp: 'ar 3/11/2004 14:24'!
thumbnail: aValue
	"This method was automatically generated"
	^self propertyValueAt: #thumbnail put: aValue with: #thumbnailChanged! !

CPlayer subclass: #CProjectBuilder
	instanceVariableNames: ''
	classVariableNames: 'DefaultConfiguration HaloMenuItems ToolMenuItems'
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder'!

CProjectBuilder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="allProjects" toSet="allProjects:" changeEvent="allProjectsChanged">allProjects</field>
	<field toGet="projectShell" toSet="projectShell:" changeEvent="projectShellChanged">projectShell</field>
	<field toGet="window" toSet="window:" changeEvent="windowChanged">window</field>
	<field toGet="worldMenu" toSet="worldMenu:" changeEvent="worldMenuChanged">worldMenu</field>
	<field toGet="projectList" toSet="projectList:" changeEvent="projectListChanged">projectList</field>
	<field toGet="lastImportDirectory" toSet="lastImportDirectory:" changeEvent="lastImportDirectoryChanged">lastImportDirectory</field>
	<field virtual="true" toGet="toolMenuItems">toolMenuItems</field>
	<field virtual="true" serializable="false" toGet="haloMenuItems">haloMenuItems</field>
	<field toGet="halo" toSet="halo:" changeEvent="haloChanged">halo</field>
	<field toGet="projectMorph" toSet="projectMorph:" changeEvent="projectMorphChanged">projectMorph</field>
</fields>'!

!CProjectBuilder class methodsFor: 'halo registry' stamp: 'ar 4/22/2005 10:42'!
haloMenuItems
	^HaloMenuItems ifNil:[HaloMenuItems := CCollection new].
! !

!CProjectBuilder class methodsFor: 'initialize' stamp: 'ar 7/13/2005 22:03'!
initialize
	"CProjectBuilder initialize"
	self initializePreferences.
	self initializeOpenCommands.
	"Make sure Tweak passByIdentity: objects are registered"
	IslandArgumentCopier initialize.! !

!CProjectBuilder class methodsFor: 'initialize' stamp: 'ar 1/23/2005 11:05'!
initializeOpenCommands
	Smalltalk allClassesDo:[:cls|
		(cls class includesSelector: #registerOpenCommand) ifTrue:[
			cls registerOpenCommand.
		].
	].! !

!CProjectBuilder class methodsFor: 'initialize' stamp: 'ar 5/29/2005 18:55'!
initializePreferences
	Preferences addPreference: #automaticWorldMenu categories: #('Tweak') default: true balloonHelp: 'When true, the world menu will be hidden as required'.
	Preferences addPreference: #profileProjectLoading categories: #('Tweak') default: false balloonHelp: 'When true, measure how much time is spent in loading projects.'.
	Preferences addPreference: #profileProjectWriting categories: #('Tweak') default: false balloonHelp: 'When true, measure how much time is spent in saving projects.'.! !

!CProjectBuilder class methodsFor: 'tcar' stamp: 'ar 4/23/2005 00:51'!
licenseText "(Workspace new) contents: self licenseText; openLabel: ''"
^ 'Copyright (c) 2001-2005 Impara GmbH, Viewpoints Research Institute, Hewlett Packard, and Contributors

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. !!
]style[(101 1025)bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0!!' readStream nextChunkText! !

!CProjectBuilder class methodsFor: 'initialize' stamp: 'ar 5/26/2005 23:52'!
methodChanged: selector from: oldMethod to: newMethod
	selector == #defaultConfiguration ifTrue:[
		"Flush config implicitly"
		DefaultConfiguration := nil.
	].
	^super methodChanged: selector from: oldMethod to: newMethod! !

!CProjectBuilder class methodsFor: 'halo registry' stamp: 'ar 4/22/2005 10:42'!
registerHaloCommand: anArray
	"The array received should be of form {'A Label String'. {TargetObject. #command}  'A Help String'} ; the final element is optional but if present will be used to supply balloon help for the menu item in the Open menu.
	If any previous registration of the same label string is already known, delete the old one."
	| item target selector |
	self unregisterHaloCommand: anArray first.
	item := CMenuItem new.
	item label: anArray first.
	target := anArray second first.
	selector := anArray second last.
	item action: (MessageSend receiver: target selector: selector).
	self haloMenuItems add: item.
! !

!CProjectBuilder class methodsFor: 'menu registry' stamp: 'sw 4/30/2005 21:28'!
registerOpenCommand: anArray
	"The array received should be of form {'A Label String'. {TargetObject. #command}  'A Help String'} ; the final element is optional but if present will be used to supply balloon help for the menu item in the Open menu.
	If any previous registration of the same label string is already known, delete the old one.
	Sort the resulting list alphabetically."

	| item target selector |
	self unregisterOpenCommand: anArray first.
	item := CMenuItem new.
	item label: anArray first.
	target := anArray second first.
	selector := anArray second last.
	item action: (MessageSend receiver: target selector: selector).
	self toolMenuItems add: item.
	self toolMenuItems sort: [:a :b | a label < b label]

	! !

!CProjectBuilder class methodsFor: 'tcar' stamp: 'ar 4/23/2005 00:49'!
tcarReleaseNotes	"(Workspace new) contents: self tcarReleaseNotes; openLabel: ''"
^ 'Tweak Core Architecture Release (TCAR)
        -- "Don''t do it if it hurts!!!!"


About this Release:
The TCAR is the release of the core parts of the Tweak architecture. It is NOT an end-user release, it is intended for early adopters and participants who wish learn the architecture early on and actively contribute. If you are looking for the end-user release, this isn''t it (yet).

Mailing list:
A mailing list exists at http://impara.de/mailman/listinfo/tweak

What is in this release:

This release contains the following parts:

* The Tweak Compiler
Since I couldn''t any longer manage the changes to the existing compiler in the form of hacks, this release simply contains a copy of the existing compiler (see category ''Tweak-Compiler''). The compiler supports method annotations (which are critical for some aspects of Tweak), positional arguments (critical for interfacing some of the scripting languages that will be supported in the future), support for "fields" (which are a carefully controlled form of implicit self) and some more.

NOTE: If you are interesting in writing a decent compiler rather than this hacked-together piece of junk, please do!!!! I''d be more than happy to throw the existing crap away.

* The asynchronous event architecture
This is one of the fundamental parts of Tweak, allowing us to provide multi-threading with clearly defined default-synchronization semantics (if you are curious, open a process browser, turn on auto-updating and watch what happens when you move over the menubar on top). The threading semantics is PRECISELY the same that we have in Morphic''s steps. Here is a little example (which will not work because the editor doesn''t support code evaluation yet ho hum, and I haven''t got the <doit> text attribute back to work...):

    button := CPushButton new.
    button label: ''Button''.
    button open.
    button waitUntil: #click.
    Smalltalk beep.

The event architecture can be found (due to historical reasons) under the ''Scripting-*'' categories.

NOTE: This stuff is currently fairly inefficient. Really there isn''t any need whatsoever to throw around as many processes as I''m doing right now - it was my way to make sure this stuff absolutely works but there''s a lot of low-hanging fruit for optimization here. So if something seems to go slowly don''t optimize on the wrong end because you see "all these processes" - they will go away as soon as it "hurts enough" to become a worthwhile target for optimization (and if you complain loudly enough it will raise to the top of the priority list much faster).

* The graphical object representation
In Tweak, all graphical objects are an assembly of a (pretty large) set of so-called "costume aspects". These aspects cover all of the areas that a graphical object may have such as:

    * their geometry
    * their fill
    * their border
    * their text
    * their graphic
    * their layout
    * ... (many others omitted) ...

The "aspects" are a fundamental part of Tweaks graphical object representation because they allow us to narrow down a broad set of interfaces into a very small one and allow delegation of this specific aspect (check out how the fill, border, or text attributes are implemented in CPlayer). Also, by the end of the day there is only "one kind" of graphical object which carries all of these aspects around - this is CPrimitiveCostume and this is one of the guys which is really off-limits. You can look but you cannot touch, but go ahead and study the aspects you find in the "Tweak-Costumes" categories.

NOTE: Some aspects are still missing or aren''t fully formed yet. If you need something that isn''t there yet, feel free to help out.

* The core Tweak architectural objects
These are found in the "Tweak-User-Kernel" category. Only six of them? No, really there is only one ;-) Most of the guys you find there have been defined because many programmers prefer to think in terms of "types" rather than "roles" and the classes found in the kernel category are intended to help them a little along those lines. But really "The One And Only" object to look at is CPlayer. It''s the center of the architecture and everything else evolves around it.

Also, there are some interim objects in the "Tweak-User-Media" category which I defined to occupy the names in the global namespace - these will be filled in as we work out the interfaces which we want to expose to these media objects.

* Tweak Widgets
There is an (almost complete) set of widgets by this time, but note that some of them are probably not structured quite right, lack some good notions so please, please, please - don''t take them for a given, I am REALLY interested in finding fundamentally good and useful notions for these widgets and if you find something that seems obscure and in the wrong place, let me know.

To give an example, after some discussion with Bert I completely changed the way buttons work because it just seemed so much more useful to have them be "state-based" - the message here is that I am interested in useful notions more than anything else.

Finally, keep in mind that the widgets have been built in the "second order theory" of Tweak rather than its first order theory (which is entirely reasonable to use - see the ColorTool for an example for first-order theory Tweak use). The reason for using the second-order theory for the widgets is because it is certain that we will want to have completely different widget sets (including native widgets) and the architecture allows for this easily.

* Tweak Tiles
The core architecture release contains the basic tile framework for Tweak. This framework has been built based on "the lessons from eToys" so that they we will be able to support various looks and feels but share the (essential) models across a wide variety of authoring environments.

Because of this, the tile framework is yet another example of the second-order theory of Tweak and you should be careful to copy what you see here "for the wrong reasons". There is no need for 90% of all user-code to make use of an advanced theory if the naive approach works likewise (often better).

* A first (somewhat rudimentary) run at the authoring environment
This what ColorTool, ProjectBuilder and friends provide. There is still a lot of work to be done and if you want to build something useful and learn about the architecture, that''s a good place to start. Just find yourself a little tool which you would find useful to have for authoring and start building it.

* An (extremely rudimentary) first run at programming tools
If it weren''t for the programming tools, Tweak would put both Morphic and MVC to its final rest - there is no reason to have any of them, Tweak doesn''t need them and being able to get rid of both is one of the ultimate goals here.

This would be another good place to start: Just take whatever tool you know from Morphic and make it work with Tweak. The rudimentary start I did on the workspace and the (not-quite-working) browser should give you a pretty good start here.

What is NOT in this release:

When I decided to ship this release for real I had to make a really hard decision between taking all of the previous stuff from alpha1 with the TCAR or not. I decided against it for a single reason: People who would look at stuff from alpha1 wouldn''t see the things they ought to see. While there were some good things in alpha1 I decided to leave them out for the single reason to make this release as concise as possible - you get only things that I have explicitly reviewed and found "good enough" to be looked at.

That''s partly why this release is poor on the "end-user notions" - all of the stuff which was in alpha1 was aimed at the end-user space, but in making (and refining) the TCAR I had to change some fundamental things and looking at any of the former stuff would just get into your way of understanding what Tweak is all about. These things will come back - based on a stronger foundation than they were and in about 1/10th of the time it took to build them originally.

Also, there is one major aspect that is missing in this release simply because I wanted to get it out - that''s the part of "constructing user interfaces". At this point one still has to "program" the user interface very much like in Morphic but the architectural hooks are there and one of the next steps will be to bring in the interactive construction back in. Until then, you are no better or worse off then with Morphic.
!!
]style[(38 41 19 285 13 67 24 46 20 664 37 751 561 1 37 940 132 1 38 708 15 1088 13 589 65 311 59 475 8 3 17 1414)FBitstreamVeraSans#20.0b,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,iFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,iFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,buFBitstreamVeraSans#16.0,bFBitstreamVeraSans#16.0,FBitstreamVeraSans#16.0!!' readStream nextChunkText! !

!CProjectBuilder class methodsFor: 'menu registry' stamp: 'ar 3/29/2004 16:47'!
toolMenuItems
	^ToolMenuItems ifNil:[ToolMenuItems := CCollection new].! !

!CProjectBuilder class methodsFor: 'halo registry' stamp: 'ar 4/22/2005 10:42'!
unregisterHaloCommand: label
	"Remove the open command with the given label from the registry"
	self haloMenuItems removeAll: 
		(self haloMenuItems select:[:each| each label = label]).
! !

!CProjectBuilder class methodsFor: 'menu registry' stamp: 'ar 3/29/2004 16:46'!
unregisterOpenCommand: label
	"Remove the open command with the given label from the registry"
	self toolMenuItems removeAll: 
		(self toolMenuItems select:[:each| each label = label]).
! !

!CProjectBuilder class methodsFor: 'menu registry' stamp: 'ar 3/29/2004 16:47'!
unregisterOpenCommandWithReceiver: aReceiver
	"Remove the open command with the given object as receiver from the registry"
	self toolMenuItems removeAll: 
		(self toolMenuItems select:[:each| each action receiver = aReceiver]).
! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 12/12/2009 20:43'!
about
	| info |
	info := String streamContents:[:s|
		s nextPutAll: 'Base version: ', SystemVersion current asString.
		s cr; nextPutAll: 'Platform: ', SmalltalkImage current platformName.
		s cr; nextPutAll: 'Update level: ', SystemVersion current highestUpdate.
		s cr.
		s cr; nextPutAll: 'Memory used: ', (Smalltalk vmParameterAt: 3) asStringWithCommas.
		s cr; nextPutAll: 'Memory free: ', (Smalltalk bytesLeft: false) asStringWithCommas.
	].

	CDialog inform: info label:'About Tweak!!'.! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 8/5/2005 12:15'!
activateProject: projectIsland
	projectShell myIsland: projectIsland.
	projectShell myProject: projectIsland project.! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/24/2004 02:58'!
addCellLayoutMenuItems: haloTarget to: aMenu
	"Cell (e.g., child) related items"
	| menu sub item |
	menu := CMenu new.
	sub := CMenu new.
	#(rigid shrinkWrap spaceFill) do:[:sym|
		item := sub add: sym target: haloTarget action: #tweak:to: arguments: {#hResizing. sym}.
		item checked: (haloTarget hResizing == sym).
	].
	sub label: 'Resizing'.
	menu add:'horizontal resizing' subMenu: sub.

	sub := CMenu new.
	#(rigid shrinkWrap spaceFill) do:[:sym|
		item := sub add: sym target: haloTarget action: #tweak:to: arguments: {#vResizing. sym}.
		item checked: (haloTarget vResizing == sym).
	].
	sub label: 'Resizing'.
	menu add:'vertical resizing' subMenu: sub.

	aMenu ifNotNil:[aMenu add: 'child options' subMenu: menu].
	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 8/19/2005 01:46'!
addDebugItems: aPlayer to: aMenu
	| menu map list item target mm first last tracer iconMap |
	iconMap := self eventIconMap.
	menu := CMenu new.
	menu label: 'Debug'.

	target := aPlayer asPrimCostume.
	[target := target player.
	target == nil] whileFalse:[
		map := target myEventMap ifNil:[Dictionary new].
		list := map keys asArray sort.
		list := list select:[:each| 
			(map at: each) notNil and:[(map at: each) anySatisfy:[:aa| aa notNil]]].
		list isEmpty ifFalse:[
			first := list reject:[:each| each endsWith: 'Changed'].
			last := list select:[:each| each endsWith: 'Changed'].
			mm := CMenu new.
			{first. last} do:[:group| group do:[:evtName|
				tracer := (map at: evtName) first.
				item := mm add: evtName target: self 
					action: #debug:event: arguments: {target. evtName}.
				item checked: (tracer isKindOf: CDebugEventTracer).
				item icon := iconMap at: evtName ifAbsent:[
					(evtName endsWith: 'changed' caseSensitive: false) 
						ifTrue:[CIconLibrary at: #ChangeEventIcon]
						ifFalse:[CIconLibrary at: #DefaultEventIcon]].

			]] separatedBy:[
				(first size > 0 and:[last size > 0]) ifTrue:[mm addSeparator].
			].
			menu add: target className subMenu: mm.
		].
	].
	aMenu ifNotNil:[aMenu add: 'break on' subMenu: menu].! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'tk 9/13/2004 15:27'!
addEmbeddingItems: target to: aMenu
	| menu parent newParent newName |
	parent := target container ifNil:[^self].
	menu := CMenu new.
	menu label: 'Become an element of'.
	(parent asPrimCostume 
		contentsAt: target position 
		behind: target asPrimCostume 
		unlocked: true) reverseDo:[:m|
			newParent := m asPlayer.
			newName := (newParent componentBinding ifNil:[newParent]) name.
			menu add: newName target: self 
				action: #embed:into: arguments: {target. newParent}.
	].
	menu menuItems size = 0 ifTrue:[^self].
	aMenu ifNotNil:[aMenu add: 'embed into' subMenu: menu].
	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/27/2004 21:00'!
addLayoutMenuItems: haloTarget to: aMenu
	| menu haloLayout item |
	menu := CMenu new.
	menu label: 'Layout Options'.
	haloLayout := haloTarget layout.
	item := menu add: 'no layout' target: haloTarget action: #tweak:to: arguments:{#layout. nil}.
	item checked: haloLayout isNil.
	item := menu add: 'simple layout' target: haloTarget action: #tweak:to: arguments:{#layout. CSimpleLayout new}.
	item checked: (haloLayout notNil and:[haloLayout isSimpleLayout]).
	item := menu add: 'proportional layout' target: haloTarget action: #tweak:to: arguments:{#layout. CProportionalLayout new}.
	item checked: (haloLayout notNil and:[haloLayout isProportionalLayout]).
	item := menu add: 'table layout' target: haloTarget action: #tweak:to: arguments:{#layout. CTableLayout new}.
	item checked: (haloLayout notNil and:[haloLayout isTableLayout]).
	menu addSeparator.
	self addCellLayoutMenuItems: haloTarget to: menu.
	self addTableLayoutMenuItems: haloTarget to: menu.
	menu label:'Layout'.
	aMenu ifNotNil:[aMenu add: 'layout' subMenu: menu].
	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/27/2004 21:05'!
addTableLayoutMenuItems: haloTarget to: aMenu
	| menu sub item optName optValue targetLayout |
	targetLayout := haloTarget layout ifNil:[^nil].
	targetLayout isTableLayout ifFalse:[^nil].
	menu := CMenu new.
	menu add: 'change layout inset...' target: self
		action: #onChangeLayoutInset: argument: haloTarget.
	menu add: 'change cell inset...' target: self
		action: #onChangeCellInset: argument: haloTarget.
	menu  addSeparator.
	#(
		('reverse table cells' reverseTableCells)
		('rubber band cells' rubberBandCells)
	) do:[:opt|
		optName := opt second.
		optValue := targetLayout perform: optName.
		item := menu add: opt first target: targetLayout action: #tweak:to: arguments:{optName. optValue not}.
		item checked: optValue.
	].

	sub := CMenu new.
	#(leftToRight rightToLeft topToBottom bottomToTop) do:[:sym|
		item := sub add: sym target: targetLayout action: #newListDirection: argument: sym.
		item checked: (targetLayout listDirection == sym).
	].
	sub label: 'Direction'.
	menu add: 'list direction' subMenu: sub.

	sub := CMenu new.
	#(none leftToRight rightToLeft topToBottom bottomToTop) do:[:sym|
		item := sub add: sym target: targetLayout action: #tweak:to: arguments:{#wrapDirection. sym}.
		item checked: (targetLayout wrapDirection == sym).
	].
	sub label: 'Direction'.
	menu add: 'wrap direction' subMenu: sub.

	sub := CMenu new.
	#(center topLeft topRight bottomLeft bottomRight topCenter leftCenter rightCenter bottomCenter) do:[:sym|
		item := sub add: sym target: targetLayout action: #tweak:to: arguments:{#cellPositioning. sym}.
		item checked: (targetLayout cellPositioning == sym).
	].
	sub label: 'Position'.
	menu add: 'cell positioning' subMenu: sub.

	sub := CMenu new.
	#(topLeft bottomRight center justified) do:[:sym|
		item := sub add: sym target: targetLayout action: #tweak:to: arguments:{#listCentering. sym}.
		item checked: (targetLayout listCentering == sym).
	].
	sub label: 'Center'.
	menu add: 'list centering' subMenu: sub.

	sub := CMenu new.
	#(topLeft bottomRight center justified) do:[:sym|
		item := sub add: sym target: targetLayout action: #tweak:to: arguments:{#wrapCentering. sym}.
		item checked: (targetLayout wrapCentering == sym).
	].
	sub label: 'Center'.
	menu add: 'wrap centering' subMenu: sub.

	menu label: 'Table Layout'.
	aMenu ifNotNil:[aMenu add: 'table options' subMenu: menu].
	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/7/2006 16:12'!
addToPartsBin: haloTarget
	"Add the target object to the parts bin."
	| labelString aDescription |
	labelString := CDialog request: 'Label to use in parts bin, please: ' initialAnswer: ''.
	labelString isEmptyOrNil ifTrue: [^ self].
	aDescription := CPartDescription new.
	aDescription label: labelString balloonHelp: 'Help to be provided' category: CPartsBin nameForAdditionsCategory creator: haloTarget selector: #copy customForm: nil.
	CPartsBin registerPartDescription: aDescription.
	CPartsBin haveInstancesShowUnclassified! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 10/20/2003 19:33'!
adjustWorldMenu
	"Adjust the world menu after a geometry change in the receiver"
	self worldMenu ifNil:[^self stopScript: #adjustWorldMenu]. "why bother"
	self worldMenu left: 0.
	self worldMenu width: self bounds width.! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:13'!
allProjects
	"This method was automatically generated"
	<bewareOf: #allProjectsChanged>
	^self propertyValueAt: #allProjects! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:24'!
allProjects: aValue
	"This method was automatically generated"
	^self propertyValueAt: #allProjects put: aValue with: #allProjectsChanged! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 12/13/2004 20:44'!
automaticWorldMenu
	^Preferences automaticWorldMenu! !

!CProjectBuilder methodsFor: 'menu' stamp: 'tak 5/26/2005 17:42'!
automaticWorldMenu: aBool
	| item |
	Preferences setPreference: #automaticWorldMenu toValue: aBool.
	"This #translated code would be not good. Do we need item ID?"
	item := (worldMenu itemNamed: 'Options' translated) subMenu itemNamed: 'Auto hide menu'.
	item checked: aBool.
	aBool ifTrue:[self startScript: #onMouseLeaveMenu].! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 8/5/2005 12:09'!
closeProject
	"Close the current project"
	allProjects remove: projectShell myIsland.
	projectShell closeProject.! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'bf 7/26/2005 13:44'!
debug: target event: eventName
	| map list tracer |
	map := target myEventMap.
	map ifNotNil:[list := map at: eventName ifAbsent:[nil]].
	list ifNotNil:[list size > 0 ifTrue:[tracer := list at: 1]].
	(tracer isKindOf: CDebugEventTracer)
		ifTrue:[^tracer unregister].

	tracer := target island new: CDebugEventTracer.
	tracer signaler: target.
	tracer eventName: eventName.
	tracer register.
! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 12/11/2009 22:08'!
debugMenu
	"Create the Debug menu and answer it"

	| menu item |
	menu := CMenu new.
	menu add: 'Refresh Display' target: self action: #refreshDisplay.
	menu add: 'Restore Cursor' target: self action: #restoreCursor.
	menu add: 'Restore World Menu' target: self action: #installWorldMenu.
	menu add: 'Rebuild Parts Library' target: self action: #rebuildPartsLibrary.
	menu addSeparator.
	menu add: 'Collect Garbage' target: self action: #garbageCollect.
	menu add: 'VM statistics' target: self action: #vmStatistics.
	menu add: 'Start MessageTally' target: self action: #startMessageTally.
	menu addSeparator.
	item := menu add: 'Save Image' target: self action: #saveImage.
	item icon: MenuIcons smallSaveIcon.
	item := menu add: 'Save Image As...' target: self action: #saveImageAs.
	item icon: MenuIcons smallSaveAsIcon.
	"more to come..."
	^menu! !

!CProjectBuilder methodsFor: 'updates' stamp: 'ar 6/8/2005 10:00'!
defaultConfiguration
	"Answer the default configuration for Tweak packages"
	^DefaultConfiguration ifNil:[DefaultConfiguration := MCConfiguration fromArray: #(
repository ('http://source.impara.de/mc')
repository ('http://source.impara.de/Tweak')
repository ('http://www.squeaksource.com/ToolBuilder')
dependency ('PackageInfo-Base' 'PackageInfo-Base-bf.22' '5f38fe9a-bcbb-11d9-8c5b-000d93ca8ba0')
dependency ('Monticello' 'Monticello-bf.255' '698c8a3a-d681-11d9-8008-000d93ca8ba0')
dependency ('MonticelloConfigurations' 'MonticelloConfigurations-bf.26' '2f3f3776-cbdf-4f62-a39f-551346e69b83')
dependency ('TweakMC' 'TweakMC-bf.11' '193eb26f-6127-4c7d-91a5-fdd7111130a8')
dependency ('Islands' 'Islands-ar.11' 'c1c39a9e-ae81-fb48-a5da-8c5ed14d61ee')
dependency ('Scripting-Preload' 'Scripting-Preload-ar.3' '9815ca00-4416-1443-8aef-adf38d436df9')
dependency ('Scripting' 'Scripting-ar.24' '31341a22-e9ed-ba47-80b5-173eeaf7eb80')
dependency ('Tweak-Preload' 'Tweak-Preload-ar.3' '9a191306-19c5-d34f-a8cd-a7eb831b7a08')
dependency ('Tweak-Hacks' 'Tweak-Hacks-ar.23' '55a10307-01d2-0245-bb63-c0eed07c7eba')
dependency ('Tweak-Text-HTML' 'Tweak-Text-HTML-ar.2' '9a6fea43-ca07-0549-ade2-4ba1908d2c2c')
dependency ('Tweak-Compiler' 'Tweak-Compiler-ar.22' 'ddc9128d-2641-624e-9075-94453d88d080')
dependency ('Tweak-Core-Proto' 'Tweak-Core-Proto-ar.40' '2cb801eb-b5dd-f441-9c3a-23b7a96d1df4')
dependency ('Tweak-Core-Object' 'Tweak-Core-Object-ar.13' '62c0bb6b-3bef-ae44-b307-e2e1e22c4405')
dependency ('Tweak-Costume' 'Tweak-Costume-ar.50' 'ce4d65b6-32c6-7346-9ebe-9d7fc0b79d28')
dependency ('Tweak-Basic' 'Tweak-Basic-tk.63' '6e39d0f5-d6ed-11d9-a5ed-000a95c7042c')
dependency ('Tweak-Maker' 'Tweak-Maker-ar.7' '0d27ffa7-4ba9-244f-a0f3-3e5876de1b90')
dependency ('Tweak-Platforms' 'Tweak-Platforms-bf.7' '3f8f4cba-d763-11d9-a715-000d93ca8ba0')
dependency ('Tweak-Widgets' 'Tweak-Widgets-ar.80' '16a7c0a7-45ee-434b-9c45-da558f25e99c')
dependency ('Tweak-Projects' 'Tweak-Projects-ar.26' '4516b3b6-0beb-0743-bba5-4b6691e3a353')
dependency ('Tweak-Morphic' 'Tweak-Morphic-ar.30' '82722785-1de3-bd47-b957-e742207837c2')
dependency ('Tweak-Books' 'Tweak-Books-ar.13' '3a7887e5-0ee9-0a4b-a0bc-7eb821ed587e')
dependency ('Tweak-Tiles' 'Tweak-Tiles-ar.60' '8bc580f1-6985-504e-aa94-48acf2a026a8')
dependency ('Tweak-Tools' 'Tweak-Tools-sw.28' 'dc6485ca-d3ba-11d9-ab14-0003935a8096')
dependency ('Tweak-Skins' 'Tweak-Skins-bf.5' 'efec38db-868b-11d9-beee-000d93ca8ba0')
dependency ('Tweak-Painter' 'Tweak-Painter-ar.11' '8c5a254f-77d6-8049-907e-4f8997583eb3')
dependency ('Tweak-Updates' 'Tweak-Updates-ar.8' '8852c40b-137b-b94f-8b5d-80c0edceb6b7')
dependency ('Tweak-DevTools' 'Tweak-DevTools-bf.32' 'cf41fab2-d763-11d9-a715-000d93ca8ba0')
dependency ('Tweak-Explain' 'Tweak-Explain-ar.14' '263ea00f-a68b-8545-bffa-388cad133088')
dependency ('Tweak-EToys' 'Tweak-EToys-ar.14' '239097c3-edaf-fa49-bde2-2dcb716b9ef0')
dependency ('Tweak-Demo' 'Tweak-Demo-ar.1' '259551a0-cdb8-944f-a461-f5cd9e43210d')
dependency ('Tweak-ProjectBuilder' 'Tweak-ProjectBuilder-ar.65' '28fb8dda-920a-d04c-9350-8f3014eda048')
dependency ('Tweak-Tests' 'Tweak-Tests-ar.19' '86db9a8d-fab7-7643-aee4-781cbe41076b')
dependency ('ToolBuilder-Kernel' 'ToolBuilder-Kernel-ar.7' 'b18374f5-32bf-9c47-a581-84a8bb200dbd')
dependency ('ToolBuilder-Examples' 'ToolBuilder-Examples-cwp.4' '03b9ef65-7efb-9741-8ff3-fac2466b067d')
dependency ('ToolBuilder-Specs' 'ToolBuilder-Specs-ar.1' '37f1e3ba-767e-244e-9d9a-1e2443ea26f6')
dependency ('ToolBuilder-SUnit' 'ToolBuilder-SUnit-cwp.6' 'd6444ddd-b148-554a-8982-47831601e52e')
dependency ('ToolBuilder-Morphic' 'ToolBuilder-Morphic-ar.7' '745fe299-d755-7448-8b2b-3474b6807eb6')
dependency ('ToolBuilder-MVC' 'ToolBuilder-MVC-ar.5' 'e20d505e-34e3-af4f-aca3-8cd7158a2728')
dependency ('ToolBuilder-Tweak' 'ToolBuilder-Tweak-ar.12' '21479cc9-95c8-d44f-9a42-e3a25e346e04')
dependency ('UIManager' 'UIManager-ar.7' '3e950479-44a2-3048-b512-d5d1f4f3052d')
dependency ('Tools-Annotations Browser' 'Tools-Annotations Browser-tk.2' '71141132-9bfb-11d9-9375-000a95c7042c')
)].! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/14/2004 13:52'!
display
	^(self window ifNil:[^nil]) display! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 2/7/2004 21:59'!
displayDepth: bpp
	self window displayDepth: bpp.
	self onUpdateDisplayDepthMenu.! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'tk 3/18/2005 15:12'!
embed: child into: newParent
	| tfm |
	tfm := child localToGlobal transformedBy: newParent globalToLocal.
	child transform: tfm.
	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	child container asPrimCostume tweaked: #contents after:[
		newParent asPrimCostume tweaked: #contents after:[
			newParent add: child.
		].
	].
	child propertyValueAt: #addedByUser put: true.
		"needed by How To Build This, CScriptForObject"
! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 8/19/2005 01:41'!
eventIconMap
	"Initialize the event map"
	| icon map |
	map := Dictionary new.
	#(
		(MouseEventIcon
			(mouseDown mouseEnter mouseMove mouseStillDown mouseLeave mouseUp
			mouseClick mouseDoubleClick mouseDrag
			dragEnter dragMove dragLeave dragDrop
			dropAccept dropReject
			redButtonDown redButtonMove redButtonUp
			yellowButtonDown yellowButtonMove yellowButtonUp
			blueButtonDown blueButtonMove blueButtonUp))

		(KeyboardEventIcon 
			(keyboardFocusEnter keyboardFocusLeave
			keyDown keyUp keyStroke))

		(StructureEventIcon
			(structureChanged frameChanged 
			layoutChanged containerLayoutChanged
			open close
			opened closed "remove those"))

		(WindowEventIcon
			(closeRequest expandRequest collapseRequest 
			activate passivate))

		(TextEventIcon
			(textModified textSelectionChanged save accept revert))

		(TickEventIcon
			(tick))

		(ButtonEventIcon
			(fire))

		(ListEventIcon
			(changed cursorChanged wrapCursorChanged))
	) do:[:spec|
		icon := CIconLibrary at: spec first.
		spec last do:[:each| map at: each put: icon].
	].
	^map! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 5/22/2005 18:59'!
exportImage
	| obj fileName file writer |
	obj := halo target.
	obj ifNil:[^Smalltalk beep].
	fileName := CFileSaveDialog openFile: #(
		('PNG' ('*.png'))
		('JPG' ('*.jpg' '*.jpeg'))
		('GIF' ('*.gif'))
		('BMP' ('*.bmp'))
	) label: 'Export image'.
	fileName ifNil:[^nil].
	file := FileStream newFileNamed: fileName.
	[file binary.
		(file name endsWith: '.png') ifTrue:[writer := PNGReadWriter].
		(file name endsWith: '.bmp') ifTrue:[writer := BMPReadWriter].
		(file name endsWith: '.gif') ifTrue:[writer := GIFReadWriter].
		(file name endsWith: '.jpg') ifTrue:[writer := JPEGReadWriter2].
	writer := writer on: file.
	writer nextPutImage: obj asForm] 
		ensure:[file close].! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 5/22/2005 18:59'!
exportObject
	| obj fileName maker |
	obj := halo target.
	obj ifNil:[^Smalltalk beep].
	fileName := CFileSaveDialog openFile: #(
			('Objects'	('*.sqp'))
		) label: 'Export Object'.
	fileName ifNil:[^self].
	(fileName endsWith: '.zip') ifTrue:[
		Cursor wait showWhile:[maker := CObjectMaker newFrom: obj].
		maker name: 'project'.
		maker saveTo: fileName.
		^self].
	Smalltalk beep.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 12/14/2009 19:18'!
fileMenu
	| menu item |
	menu := CMenu new.
	item := menu add: 'New Project...' target: self action: #newProject.
	item := menu add: 'Open Project...' target: self action: #openProject.
	item := menu add: 'Close Project' target: self action: #closeProject.
	menu addSeparator.
	item := menu add: 'Save Project' target: self action: #saveProject.
	item icon: MenuIcons smallSaveIcon.
	item := menu add: 'Save Project As...' target: self action: #saveProjectAs.
	item icon: MenuIcons smallSaveAsIcon.
	menu addSeparator.
	menu add: 'Project Overview...' target: self action: #projectOverview.
	menu addSeparator.
	menu add: 'Import Object...' target: self action: #importObject.
	menu add: 'Export Object...' target: self action: #exportObject.
	menu add: 'Export Image...' target: self action: #exportImage.
	menu addSeparator.
	menu add: 'Print' target: self action: #notYet disabled: true.
	menu add: 'Page setup' target: self action: #notYet disabled: true.
	menu addSeparator.
	item := menu add: 'Quit' target: self action: #quit.
	item icon: MenuIcons smallQuitIcon.
	^menu! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 3/13/2004 17:13'!
garbageCollect
	"Collect garbage and report memory statistics"
	| spaceUsed spaceLeft reserve info |
	Smalltalk garbageCollect.
	spaceLeft := Smalltalk bytesLeft: false.
	reserve := Smalltalk bytesLeft: true.
	spaceUsed := Smalltalk vmParameterAt: 3.
	info := String streamContents:[:s|
		s nextPutAll: 'Used:	', spaceUsed asStringWithCommas, ' bytes'.
		s cr; nextPutAll: 'Free:	', spaceLeft asStringWithCommas, ' bytes'.
		s cr; nextPutAll: 'Swap: ', reserve asStringWithCommas, ' bytes'.
	].
	CDialog inform: info label: 'Memory statistics'.
! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 12/11/2009 21:39'!
getHaloMenu: haloTarget
	"Create and answer a halo menu for the given halo target"

	| menu aMenu item |
	menu := CMenu new.
	menu label: (haloTarget name truncateTo: 30).
	item := menu add: 'inspect' target: haloTarget action: #inspect.
	item balloonHelp: 'Inspect this object'.
	aMenu := self getSaveCostumeMenu: haloTarget.
	aMenu ifNotNil:[menu add: 'save costume for' subMenu: aMenu].
	"aMenu := haloTarget getMessageMenu.
	aMenu label: nil.
	menu add: 'messages' subMenu: aMenu.
	menu addSeparator."

	item := menu add: 'tile for player' target: self
		action: #getTileForPlayer: argument: haloTarget.
	item balloonHelp: 'Hand me a tile for this object'.
	item := menu add: 'tile for value' target: self
		action: #getTileForValue: argument: haloTarget.
	item balloonHelp:'Hand me a tile for this object''s value'.
	item := menu add: 'grab me' target: self 
		action: #grabObject: argument: haloTarget.
	item balloonHelp:'Grab this object'.
	item := menu add: 'repaint' target: CPainter
		action: #openOnTarget: argument: haloTarget.
	item balloonHelp:'Repaint this object''s graphic'.
	menu addSeparator.

	menu add: 'send to back' target: self 
		action: #sendToBack: argument: haloTarget.
	menu add: 'come to front' target: self 
		action: #sendToFront: argument: haloTarget.

	self addEmbeddingItems: haloTarget to: menu.
	menu addSeparator.

	"self addFactoryItemsTo: menu."
	self addLayoutMenuItems: haloTarget to: menu.
	menu addSeparator.
	item := menu add: 'add to parts bin' target: self action: #addToPartsBin: argument: haloTarget.
	item balloonHelp: 'Add this object to the parts bin.  The effect will be that you can drag fresh copies of it out of any parts bin at any time in the future.  The item will initially appear in the "unclassified" category, but you can subsequently move it anywhere you wish.'.
	menu addSeparator.
	menu add: '[debug] explore' target: haloTarget action: #explore.
	Smalltalk at: #CHeartbeat ifPresent: [:heartbeat |
		menu add: '[debug] events' target: heartbeat
			action: #openHeartbeatOn: argument: haloTarget].
	self addDebugItems: haloTarget to: menu.

	menu menuItems addAll: ((haloMenuItems collect:[ :each | 
		| newItem |  
		newItem := each copy.  "should be shallowCopy, but properties are not shallowCopied yet"
		newItem action: (newItem action shallowCopy arguments: {haloTarget.}).
		newItem]) sort: [ :a :b | a label <= b label ]).

	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/17/2004 11:44'!
getSaveCostumeMenu: aPlayer
	| target menu |
	target := aPlayer player ifNil:[^nil].
	menu := CMenu new.
	menu label: 'Save Costume'.
	[target == nil] whileFalse:[
		menu add: target class name allButFirst target: self action: #saveCostume:for: arguments:{aPlayer. target}.
		target := target player.
	].
	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 6/27/2005 13:47'!
getTileForPlayer: target
	target tileForSelf openInHand.! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/25/2004 19:04'!
getTileForValue: target
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 5/22/2005 19:11'!
halo
	"Answer the halo of the receiver"
	<bewareOf: #haloChanged>
	^(self propertyValueAt: #halo) ifNil:[| hh |
		hh := CHalo new.
		hh beHalo.
		self halo: hh.
		hh]
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 5/22/2005 18:56'!
halo: aValue
	"Modify the receiver's halo"
	^self propertyValueAt: #halo put: aValue with: #haloChanged! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 4/22/2005 10:43'!
haloMenuItems
	^self class haloMenuItems! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 4/23/2005 00:44'!
helpMenu
	| menu |
	menu := CMenu new.
	menu add: 'Load updates...' target: self action: #loadUpdates.
	"menu add: 'Choose updates...' subMenu: self updatesMenu."
	menu addSeparator.
	menu add: 'Release notes...' target: self action: #showReleaseNotes.
	menu add: 'License...' target: self action: #showLicense.
	menu addSeparator.
	menu add: 'About...' target: self action: #about.
	^menu! !

!CProjectBuilder methodsFor: 'media' stamp: 'ar 6/5/2005 12:22'!
importObject
	"Open a file"
	| fileName file object objectTypes pictureTypes musicTypes movieTypes allTypes dialog |
	objectTypes := #('*.zip' '*.sqp').
	pictureTypes := #('*.gif' '*.jpg' '*.bmp' '*.png' '*.jpeg').
	musicTypes := #('*.wav' '*.mp3' '*.au' '*.mid').
	movieTypes := #('*.mpg' '*.jmv').
	allTypes := objectTypes, pictureTypes, musicTypes, movieTypes.
	dialog := CFileOpenDialog new.
	dialog directory: (lastImportDirectory ifNil:[FileDirectory default]).
	fileName := dialog openFile: {
		{'All Media'. allTypes}.
		{'Objects'. objectTypes}.
		{'Pictures'. pictureTypes}.
		{'Music'. musicTypes}.
		{'Movies'. movieTypes}.
	} label: 'Import Object'.
	fileName ifNil:[^self].
	lastImportDirectory := dialog directory.
	file := projectShell myIsland 
		new: FileStream 
		constructor: #readOnlyFileNamed: 
		arguments: {fileName}.
	[
		(objectTypes any match: fileName) 
			ifTrue:[object := projectShell myProject importObjectFrom: file].
		(pictureTypes any match: fileName)
			ifTrue:[object := projectShell myProject importImageFrom: file].
		(musicTypes any match: fileName)
			ifTrue:[object := projectShell myProject importSoundFrom: file].
		(movieTypes any match: fileName)
			ifTrue:[object := projectShell myProject importMovieFrom: file].
	] ensure:[file close].
	object ifNotNil:[object openCenteredIn: projectShell myProject world].! !

!CProjectBuilder methodsFor: 'menu' stamp: 'tk 2/24/2005 10:37'!
inWidgetMenu: aClassName
	"Return true if an instance of this class can be created in the Widgets menu"

	^ ((worldMenu itemNamed: 'Widgets') subMenu subItemNamed: aClassName) ~~ nil! !

!CProjectBuilder methodsFor: 'initialize' stamp: 'ar 8/5/2005 13:05'!
initialize
	super initialize.
	self allProjects: CCollection new.
	projectShell := CProjectShell new.
	projectList := self newProjectList.
	self newProject.
	worldMenu := CMenuBar new. "will be clobbered immediately"
	self startScript: #installWorldMenu.! !

!CProjectBuilder methodsFor: 'initialize' stamp: 'ar 2/4/2005 21:10'!
installWorldMenu
	<on: updateWorldMenu> "cheesy but simple way out to restore it, e.g.,
		CProjectBuilder allInstancesDo:[:each| each signal: #updateWorldMenu].
	"
	self worldMenu ifNotNil:[self worldMenu close].
	self worldMenu: self newWorldMenu.! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 4/3/2004 13:55'!
lastImportDirectory
	"Answer the lastImportDirectory of the receiver"
	<bewareOf: #lastImportDirectoryChanged>
	^self propertyValueAt: #lastImportDirectory! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 4/3/2004 13:55'!
lastImportDirectory: aValue
	"Modify the receiver's lastImportDirectory"
	^self propertyValueAt: #lastImportDirectory put: aValue with: #lastImportDirectoryChanged! !

!CProjectBuilder methodsFor: 'updates' stamp: 'ar 12/12/2009 20:42'!
loadUpdates
	MCMcmUpdater updateFromRepositories: #(
		'http://squeaksource.com/TweakCore'
		'http://squeaksource.com/TweakExtras'
	).! !

!CProjectBuilder methodsFor: 'tools' stamp: 'ar 7/14/2005 15:19'!
makeNewDrawing
	"Create a new drawing"
	| painter aPlayer aForm bForm bPlayer sprite |
	painter := self makeNewPainter: 32.
	painter waitUntil: #close.
	"Need to recreate both form and player from painter"
	aPlayer := painter newPlayer ifNil:[^self].
	aPlayer close.

	aForm := aPlayer graphicForm.
	bForm := projectShell myIsland new: Form 
		constructor: #extent:depth: 
		arguments:{aForm extent. aForm depth}.
	aForm displayOn: bForm.

	bPlayer := projectShell myIsland new: CPlayer.
	bPlayer nose: 0@-1.
	bPlayer graphicForm: bForm.
	bPlayer graphicFit: #stretch.
	bPlayer preciseCollisions: true.
	bPlayer bounds: aPlayer bounds.

	sprite := projectShell myIsland new: CSprite.
	sprite costume: bPlayer.
	sprite spriteCostumes add: bPlayer.
	sprite name: 'Painting'.
	sprite nose: 0@-1.
	sprite bounds: bPlayer bounds.
	projectShell projectWorld add: sprite.
! !

!CProjectBuilder methodsFor: 'tools' stamp: 'ar 7/14/2005 15:20'!
makeNewPainter: depth
	"Create a new drawing"
	| painter box |
	box := projectShell localBounds insetBy: projectShell borderWidth.
	painter := CPainter new.
	painter borderWidth: 0.
	painter bounds: box.
	painter board painting: (Form extent: box extent depth: depth).
	projectShell add: painter.
	^painter! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 10/20/2003 19:37'!
memoryInfo
	"Collect garbage and report memory statistics"
	| spaceUsed spaceLeft reserve |
	spaceLeft := Smalltalk bytesLeft: false.
	reserve := Smalltalk bytesLeft: true.
	spaceUsed := Smalltalk vmParameterAt: 3.
	^String streamContents:[:s|
		s nextPutAll: 'Memory statistics:'; cr; cr.
		s nextPutAll: 'Used:	', spaceUsed asStringWithCommas, ' bytes'; cr.
		s nextPutAll: 'Free:	', spaceLeft asStringWithCommas, ' bytes'; cr; cr.
		s nextPutAll: 'Reserve: ', reserve asStringWithCommas, ' bytes'; cr.
	].! !

!CProjectBuilder methodsFor: 'menu' stamp: 'tk 2/24/2005 11:31'!
menuPathTo: aClassName startingAt: aMenuName
	"Return the path the an item of this name.  Start with the menu mentioned."

	| below |
	below := (worldMenu itemNamed: aMenuName) subMenu pathToItem: aClassName.
	^ below size > 0 ifTrue: [{aMenuName}, below] ifFalse: [below].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 3/26/2004 21:17'!
move: aPlayer by: delta
	| oldValue newValue parent |
	oldValue := aPlayer position.
	parent := aPlayer container.
	parent gridEnabled ifTrue:[
		newValue := oldValue + (delta * parent grid extent).
	] ifFalse:[
		newValue := oldValue + delta.
	].
	aPlayer position: newValue.
	aPlayer tweaked: #position from: oldValue to: newValue.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'tk 7/14/2004 11:27'!
moveDownLayer: aTarget
	| aCostume |
	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	aCostume := aTarget asPrimCostume.
	aCostume container tweaked: #contents
		after:[aCostume moveDownLayer].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'tk 7/14/2004 11:28'!
moveUpLayer: aTarget
	| aCostume |
	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	aCostume := aTarget asPrimCostume.
	aCostume container tweaked: #contents
		after:[aCostume moveUpLayer].! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 8/5/2005 13:09'!
newProject
	"Create a new project"
	projectList itemMaker := CProjectIslandCostume. "for old project builders"
	projectShell newProject.
	allProjects add: projectShell myIsland.! !

!CProjectBuilder methodsFor: 'tools' stamp: 'ar 8/5/2005 12:08'!
newProjectList
	| list |
	list := CList new.
	list allowDeselect: false.
	list itemMaker: CProjectIslandCostume.
	list items: self allProjects.
	^list! !

!CProjectBuilder methodsFor: 'menu' stamp: 'tak 5/26/2005 17:24'!
newWorldMenu
	| menu |
	menu := CMenuBar new.
	menu add: 'File' translated subMenu: self fileMenu.
	menu add: 'Tools' translated subMenu: self toolsMenu.
	menu add: 'Widgets' translated subMenu: self widgetsMenu.
	"menu add: 'Library' translated subMenu: self libraryMenu."
	menu add: 'Options' translated subMenu: self optionMenu.
	menu add: 'Debug' translated subMenu: self debugMenu.
	menu add: '?' translated subMenu: self helpMenu.
	^menu! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/25/2004 22:24'!
onChangeCellInset: haloTarget
	| inset |
	inset := CDialog request: 'Cell Inset:' initialAnswer: haloTarget layout cellInset printString.
	inset ifNil:[^self].
	haloTarget layout tweak: #cellInset to: (Object readFrom: inset).! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 3/25/2004 22:24'!
onChangeLayoutInset: haloTarget
	| inset |
	inset := CDialog request: 'Layout Inset:' initialAnswer: haloTarget layoutInset printString.
	inset ifNil:[^self].
	haloTarget tweak: #layoutInset to: (Object readFrom: inset).! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 6/5/2005 17:42'!
onDropFiles: anEvent
	"Handle a number of dropped files from the OS."
	| numFiles stream |
	<on: dropFiles>
	numFiles := anEvent contents.
	1 to: numFiles do: [:i |
		stream := FileStream requestDropStream: i.
		[projectShell myProject dropFile: stream] ensure:[stream close].
	].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 5/28/2005 14:05'!
onHaloChanged
	<on: haloChanged in: projectShell>
	halo := projectShell halo.
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 2/23/2004 01:41'!
onHaloCopy
	self halo target ifNil:[^self].
	Cursor wait showWhile:[
		self waitTick.
		CClipboard clipboardClear.
		CClipboard clipboardAt: 'Squeak Player' put: self halo target.
		self waitTick.
	].
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 1/20/2004 18:45'!
onHaloDebug: aHandle
	<on: haloDebug>
	self halo target inspect.
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:06'!
onHaloDismiss: aHandle
	"The user pressed the dismiss handle on the halo..."

	| haloTarget |
	<on: haloDismiss>
	(self waitHaloAction: aHandle) ifFalse:[^self].
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self closeProject].
	self halo target: nil.
	haloTarget container ifNotNil:
		[haloTarget container asPrimCostume tweaked: #contents after:
			[haloTarget playersForTrash do:
				[:aPlayer | 
					projectShell myProject trashManager addToTrash: aPlayer.
					aPlayer close]]].
	haloTarget close! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:08'!
onHaloDrag: aHandle
	| lastPt nextPt delta haloTarget oldPos |
	<on: haloDrag>
	"note: does not recompute transform every frame"
	lastPt := self hand position. "global!!"
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	oldPos := haloTarget position.
	self trackHaloHandle: aHandle in:[
		nextPt := self hand position. "global!!"
		haloTarget container 
			ifNil:[delta := nextPt - lastPt]
			ifNotNil:[delta := (haloTarget container globalToLocal: nextPt) - 
					(haloTarget container globalToLocal: lastPt)].
		haloTarget costume moveBy: delta.
		lastPt := nextPt.
	].
	haloTarget tweaked: #position from: oldPos to: haloTarget position.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:08'!
onHaloDup: aHandle
	| dup tfm haloTarget |
	<on: haloDup>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	tfm := haloTarget localToWorld.
	dup := haloTarget copy.
	dup openIn: haloTarget world.
	dup transform: tfm.
	self halo target: dup.
	self onHaloGrab: aHandle.
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 5/22/2005 19:15'!
onHaloEvent: aHandle
	| eventName |
	<on: haloEvent in: halo>
	eventName := aHandle value.
	self halo target ifNil:[^self].
	eventName ifNil:[^self].
	self signal: eventName with: aHandle! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:08'!
onHaloGrab: aHandle
	| haloTarget parent aHand |
	<on: haloGrab>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	parent := haloTarget container.
	haloTarget transform: haloTarget localToWorld.

	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	parent asPrimCostume tweaked: #contents after:[
		haloTarget world add: haloTarget.
	].
	aHand := aHandle hand.
	halo elements do:[:each| each visible: each == aHandle].
	aHand releaseMouseFocus: aHandle.
	aHandle locked: true.
	haloTarget startScript: #onDrag.
	aHand waitUntil: #mouseUp.
	aHandle locked: false.
	halo elements do:[:each| each visible: true].
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'bf 7/29/2005 13:56'!
onHaloKeyDown: evt
	| action |
	<on: keyDown in: halo>
	self halo target == projectShell myProject world ifTrue:[^self].
	self flag: #fixme. "should have halo keymap in CPlatform"
	action := CPlatform current standardEditingKeys lookupEvent: evt.
	action == #copySelection ifTrue:[self onHaloCopy].
	action == #pasteSelection ifTrue:[self onHaloPaste].
	action == #accept ifTrue:[self onHaloSave].
	action == #moveCursorLeft ifTrue:[^self move: self halo target by: -1@0].
	action == #moveCursorRight ifTrue:[^self move: self halo target by:  1@0].
	action == #moveLineUp ifTrue:[^self move: self halo target by: 0@-1].
	action == #moveLineDown ifTrue:[^self move: self halo target by: 0@1].
	action == #moveWordLeft ifTrue:[^self turn: self halo target by: -1].
	action == #moveWordRight ifTrue:[^self turn: self halo target by: 1].
	action == #scrollLineUp ifTrue:[^self moveUpLayer: self halo target].
	action == #scrollLineDown ifTrue:[^self moveDownLayer: self halo target].
	action == #selectCursorLeft ifTrue:[^self resize: self halo target by: -1@0].
	action == #selectCursorRight ifTrue:[^self resize: self halo target by:  1@0].
	action == #selectLineUp ifTrue:[^self resize: self halo target by: 0@-1].
	action == #selectLineDown ifTrue:[^self resize: self halo target by: 0@ 1].
! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 2/23/2004 22:31'!
onHaloMenu: aHandle
	<on: haloMenu>
	(self getHaloMenu: self halo target) openAt: self hand position.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 2/23/2004 01:24'!
onHaloPaste
	| pastee |
	self halo target ifNil:[^self].
	pastee := CClipboard clipboardAt: 'Squeak Player'.
	pastee ifNil:[^self].
	self onPastePlayer: pastee.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 5/22/2005 18:58'!
onHaloRecolor: aHandle
	| tool |
	<on: haloRecolor>
	tool := aHandle island new: CColorTool.
	tool halo: halo.
	tool openAt: self halo bounds topRight + (25@-20).! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 2/29/2004 01:25'!
onHaloRename: aString
	| haloTarget |
	<on: haloRename>
	haloTarget := self halo target.
	haloTarget name: aString.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:20'!
onHaloRepaint: aHandle
	| haloTarget painter aForm bForm |
	<on: haloRepaint>
	painter := self makeNewPainter: 32.
	haloTarget := self halo target.
	haloTarget visible: false.
	painter target: haloTarget.
	painter waitUntil: #close.
	projectShell tool: nil.
	haloTarget visible: true.

	aForm := haloTarget graphicForm.
	aForm island == haloTarget island ifFalse:[
		bForm := haloTarget island new: Form 
			constructor: #extent:depth: 
			arguments:{aForm extent. aForm depth}.
		aForm displayOn: bForm.
		haloTarget graphicForm: bForm.
	].
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:09'!
onHaloRotate: aHandle
	| lastPt nextPt rotCenter haloTarget oldAngle |
	<on: haloRotate>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	oldAngle := haloTarget rotation.
	rotCenter := haloTarget localToGlobal: haloTarget pivot.
	lastPt := self hand position. "global!!"
	self trackHaloHandle: aHandle in:[
		self halo pivotHolder visible: true.
		self halo noseHolder visible: true.
		nextPt := self hand position.
		self rotateHaloTarget: haloTarget from: lastPt to: nextPt center: rotCenter.
		lastPt := nextPt.
	].
	oldAngle = haloTarget rotation ifFalse:[
		haloTarget tweaked: #rotation from: oldAngle to: haloTarget rotation.
	].
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 6/5/2005 12:23'!
onHaloSave
	"We need to rethink this"
	Smalltalk beep.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 7/14/2005 15:09'!
onHaloSize: aHandle
	|  aPoint offset haloTarget oldExtent |
	<on: haloSize>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	offset := (haloTarget costume globalToLocal: self hand position) - 
		haloTarget costume localBounds corner.
	oldExtent := haloTarget extent.
	self trackHaloHandle: aHandle in:[
		aPoint := haloTarget globalToLocal: self hand position.
		haloTarget extent: aPoint - offset - haloTarget localBounds origin.
	].
	oldExtent = haloTarget extent ifFalse:[
		haloTarget tweaked: #extent from: oldExtent to: haloTarget extent.
	].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'sw 5/18/2005 12:25'!
onHaloTile: aHandle
	"The user has clicked on the hand-me-a-tile halo handle of an object"

	<on: haloTile>
	self getTileForPlayer: self halo target! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 5/29/2005 17:45'!
onHaloViewer: aHandle
	"The user has clicked on the open-viewer halo handle of an object"

	| haloTarget viewer viewerTarget flap |
	<on: haloViewer>
	haloTarget := self halo target.
	viewerTarget := haloTarget player ifNil: [haloTarget].
	hand shiftPressed ifTrue:[
		viewer := CTileInspector open.
		viewer target: viewerTarget.
		^nil].
	Preferences viewersInFlaps ifTrue:[
		flap := projectShell myIsland 
			new: CViewerFlap 
			constructor: #openForTarget:inWorld: 
			arguments:{viewerTarget. projectShell projectWorld}.
		flap ifNotNil:[flap topOffset: projectShell borderWidth asPoint y].
	] ifFalse:[
		CTileDefinition openDefaultViewerOn: viewerTarget
	].! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 5/28/2005 14:07'!
onLayoutChanged
	| box pos |
	<on: layoutChanged>
	box := self localBounds.
	worldMenu left: box left.
	worldMenu width: box width.
	worldMenu visible 
		ifTrue:[pos := worldMenu fullBounds bottomLeft]
		ifFalse:[pos := box topLeft].
	projectList topLeft: pos.
	projectList height: box height - projectList top.
	projectShell ifNotNil:[
		projectList visible ifTrue:[pos := projectList topRight].
		projectShell topLeft: pos.
		projectShell extent: self extent - projectShell topLeft.
	].
! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 12/13/2004 18:04'!
onMouseEnterMenu
	<on: mouseEnter in: worldMenu>
	worldMenu top: 0.! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 12/13/2004 20:46'!
onMouseLeaveMenu
	| max script evt delay |
	<on: mouseLeave in: worldMenu>
	self automaticWorldMenu ifFalse:[^nil].
	max := 1-worldMenu height.
	script := self startScript:[
		(Delay forSeconds: 2) wait.
		self automaticWorldMenu ifTrue:[
			delay := Delay forMilliseconds: 50.
			0 to: 20 do:[:i|worldMenu top: max * i // 20. delay wait].
			worldMenu top: max.
		].
	].
	evt := self waitUntilAnyOf:{
		script. #done.
		worldMenu. #mouseEnter
	}.
	evt selector == #mouseEnter ifTrue:[
		self stopScript: script.
	].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 2/27/2004 18:37'!
onPasteBorder: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	self halo target ifNil:[^self].
	#(borderStyle borderWidth borderColor) do:[:field|
		self halo target tweak: field to: (aPlayer get: field).
	].
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 6/24/2005 21:05'!
onPasteEmbed: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	| copy |
	self halo target ifNil:[^self].
	copy := aPlayer copy.
	copy topLeft: 0@0.
	self halo target add: copy.
	self halo target: copy.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 2/27/2004 18:37'!
onPasteFill: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	self halo target ifNil:[^self].
	#(fillStyle fillColors fillAlpha fillAngle fillOffset) do:[:each|
		self halo target tweak: each to: (aPlayer get: each).
	].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 6/25/2005 20:21'!
onPasteGeometry: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	| pos haloTarget |
	(haloTarget := self halo target) ifNil:[^self].
	pos := haloTarget position.
	haloTarget tweak: #transform to: aPlayer transform.
	haloTarget tweak: #extent to: aPlayer extent.
	haloTarget tweak: #position to: pos.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 12/19/2004 16:47'!
onPasteGraphic: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	self halo target ifNil:[^self].
	#(graphicForm graphicFit graphicOffset graphicAnchorPoint "sourceRect") do:[:each|
		self halo target tweak: each to: (aPlayer get: each).
	].! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 3/24/2004 02:55'!
onPasteLayout: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	| haloTarget |
	(haloTarget := self halo target) ifNil:[^self].
	haloTarget tweak: #layout to: aPlayer layout copy.
	haloTarget tweak: #hResizing to: aPlayer hResizing.
	haloTarget tweak: #vResizing to: aPlayer vResizing.
	haloTarget tweak: #layoutFrame to: aPlayer layoutFrame copy.
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 12/19/2004 17:41'!
onPastePlayer: aPlayer
	"Paste aPlayer (or one of its aspects) into the currently selected player"
	| menu item |
	menu := CMenu new.
	menu add: 'embed into' target: self action: #onPasteEmbed: argument: aPlayer.
	menu addSeparator.
	item := menu add: 'paste fill' target: self action: #onPasteFill: argument: aPlayer.
	item disabled: aPlayer fill isNoFill.
	item := menu add: 'paste border' target: self action: #onPasteBorder: argument: aPlayer.
	item disabled: aPlayer border isNoBorder.
	menu add: 'paste geometry' target: self action: #onPasteGeometry: argument: aPlayer.
	item := menu add: 'paste graphic' target: self action: #onPasteGraphic: argument: aPlayer.
	item enabled: aPlayer graphic notNil.
	menu addSeparator.
	menu add: 'paste layout' target: self action: #onPasteLayout: argument: aPlayer.
	menu label: aPlayer name.
	menu openAt: self hand position.
	menu run.! !

!CProjectBuilder methodsFor: 'project list' stamp: 'ar 8/5/2005 12:12'!
onProjectListCursorChanged
	"Switch to the selected project"
	<on: cursorChanged in: projectList>
	projectList cursor = 0 ifFalse:[self activateProject: projectList selection].! !

!CProjectBuilder methodsFor: 'project list' stamp: 'ar 8/5/2005 12:07'!
onProjectListMenu
	| menu |
	"<on: yellowButtonDown in: projectList>"
	menu := self projectListMenu.
	menu openAt: hand position.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 3/29/2004 16:50'!
onToolMenuItemsChanged
	<on: changed in: toolMenuItems>
	self installWorldMenu. "a cheap way out ;-)"! !

!CProjectBuilder methodsFor: 'top window' stamp: 'ar 12/20/2004 22:32'!
onTopWindowChanged: newWindow from: oldWindow
	"update top window"
	<on: topWindowChanged>
	oldWindow ifNotNil:[oldWindow signal: #passivate].
	newWindow ifNotNil:[newWindow signal: #activate].
! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 10/20/2003 19:42'!
onUpdateDisplayDepthMenu
	| item |
	self worldMenu ifNil:[^self].
	item := (self worldMenu itemNamed: 'Options') ifNil:[^self].
	item := (item subMenu itemNamed: 'Display depth') ifNil:[^self].
	self onUpdateDisplayDepthMenu: item subMenu.! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 3/14/2004 13:51'!
onUpdateDisplayDepthMenu: aMenu
	| label item display |
	display := self display.
	#(1 2 4 8 16 32) do:[:bpp|
		label := bpp printString,' bpp'.
		item := aMenu itemNamed: label.
		display ifNotNil:[
			item enabled: (display supportsDisplayDepth: bpp).
			item checked: (display depth = bpp).
		].
	].! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 10/20/2003 19:43'!
onUpdateDisplaySizeMenu
	| item |
	self worldMenu ifNil:[^self].
	item := (self worldMenu itemNamed: 'Options') ifNil:[^self].
	item := (item subMenu itemNamed: 'Display size') ifNil:[^self].
	self onUpdateDisplaySizeMenu: item subMenu.! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 10/20/2003 19:43'!
onUpdateDisplaySizeMenu: aMenu
	| item other label |
	other := true.
	{1024@768.	800@600.	640@480} do:[:pt|
		label := pt x printString, 'x', pt y printString.
		item := aMenu itemNamed: label.
		item checked: self display extent = pt.
		self display extent = pt ifTrue:[other := false].
	].
	aMenu menuItems last checked: other.
	other ifTrue:[
		label := self display width printString, 'x', self display height printString.
		aMenu menuItems last label: 'Other (', label,')'.
	] ifFalse:[
		aMenu menuItems last label: 'Other ...'.
	].
! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 6/1/2005 20:59'!
onUpdateProjectSizeMenu: aMenu
	self flag: #removeMe.! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 11/29/2004 15:37'!
onWindowChanged
	"My window has been resized"
	<on: windowChanged>
	self onWindowResize.! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 11/29/2004 15:36'!
onWindowResize
	"My window has been resized"
	<on: geometryChanged in: window>
	extent = window extent ifFalse:[
		position := 0@0.
		extent := window extent].! !

!CProjectBuilder methodsFor: 'events' stamp: 'ar 12/14/2009 19:16'!
onWorldMenuChanged
	"Set aMenu as the world's menu bar"
	<on: worldMenuChanged>
	self stopScript: #adjustWorldMenu.
	self worldMenu ifNil:[^self].
	self worldMenu hResizing: #rigid.
	self worldMenu topLeft: 0@0.
	self adjustWorldMenu.
	self add: self worldMenu.
	self startScript: #adjustWorldMenu when: {self. #geometryChanged}.! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 10/20/2003 19:48'!
openImageFile
	"An example for using file specs"
	"ActiveHand world openImageFile"
	^self openFile: #(
		('Image Files' ('*.jpg' '*.gif' '*.png' '*.bmp'))
		('JPEG Files' ('*.jpg' '*.jpeg'))
		('GIF Files' ('*.gif'))
		('PNG Files' ('*.png'))
		('BMP Files' ('*.bmp'))
		('All Files' ('*'))
	)! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 8/5/2005 12:09'!
openProject
	"Open a new project"
	| fileName file sema |
	fileName := CFileOpenDialog openFile: #(
		('Projects'	('*.prj'))
	) label: 'Open Project'.
	fileName ifNil:[^self].
	self waitTick.

	Preferences profileProjectLoading ifTrue:[
		sema := Semaphore new.
		self startScript:[MessageTally spyOnScript:[sema wait]].
		self waitTick.
	].

	[
		file := FileStream readOnlyFileNamed: fileName.
		[projectShell readProjectFrom: file] ensure:[file close].
		projectShell fileName: fileName.
		allProjects add: projectShell myIsland.
		self waitTick. "to allow profiler to capture redraw"

	] ensure:[
		sema ifNotNil:[sema signal].
	].! !

!CProjectBuilder methodsFor: 'tools' stamp: 'ar 2/24/2004 23:11'!
openProjectList
	self newProjectList open.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 5/28/2005 14:10'!
openTool: message
	| tool |
	projectShell ifNil:[^message value].
	tool := CDragMaker new.
	tool maker: message receiver.
	tool msg: message selector.
	projectShell newTool: tool.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 5/28/2005 14:10'!
openWidget: aClass
	| tool |
	projectShell ifNil:[aClass newSample openInHand].
	tool := CDragMaker new.
	tool maker: aClass.
	tool msg: #newSample.
	projectShell newTool: tool.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 6/1/2005 21:00'!
optionMenu
	| menu item |
	menu := CMenu new.
	item := menu add: 'Show project list' target: self action: #toggleProjectList.
	item checked: projectList visible.
	item := menu add: 'Auto hide menu' target: self action: #toggleWorldMenu.
	item checked: Preferences automaticWorldMenu.
	item := menu add: 'Set background' target: self action: #setBackgroundPicture.
	item := menu add: 'Toggle fullscreen' target: self action: #toggleFullScreen.
	^menu! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 6/1/2005 21:00'!
projectExtent: newExtent
	self flag: #removeMe.
! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/14/2004 13:13'!
projectList
	"Answer the projectList of the receiver"
	<bewareOf: #projectListChanged>
	^self propertyValueAt: #projectList! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/14/2004 13:13'!
projectList: aValue
	"Modify the receiver's projectList"
	^self propertyValueAt: #projectList put: aValue with: #projectListChanged! !

!CProjectBuilder methodsFor: 'project list' stamp: 'ar 2/6/2005 23:56'!
projectListMenu
	| menu item |
	menu := CMenu new.
	menu label: 'Project list options'.
	item := menu add: 'Thumbnail view' target: projectList action: #itemMaker: arguments:{CProjectCostume}.
	item checked: projectList itemMaker == CProjectCostume.
	item := menu add: 'List view' target: projectList action: #itemMaker: arguments:{CProjectListCostume}.
	item checked: projectList itemMaker == CProjectListCostume.
	^menu! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 12/14/2009 19:29'!
projectMorph
	"Answer the projectMorph of the receiver"
	<bewareOf: #projectMorphChanged>
	^self propertyValueAt: #projectMorph! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 12/14/2009 19:29'!
projectMorph: aValue
	"Modify the receiver's projectMorph"
	^self propertyValueAt: #projectMorph put: aValue with: #projectMorphChanged! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 5/28/2005 14:00'!
projectShell
	"Answer the projectShell of the receiver"
	<bewareOf: #projectShellChanged>
	^self propertyValueAt: #projectShell! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 5/28/2005 14:00'!
projectShell: aValue
	"Modify the receiver's projectShell"
	^self propertyValueAt: #projectShell put: aValue with: #projectShellChanged! !

!CProjectBuilder methodsFor: 'initialize' stamp: 'ar 12/14/2009 19:32'!
quit
	| wnd |
	(self confirm: 'Quit Tweak?') ifFalse:[^false].
	wnd := 	self projectMorph.
	wnd ifNil:[
		self halt: 'This needs fixing'.
	] ifNotNil:[
		"Workaround until this can be fixed properly... File/exit from fullScreen
 		sometimes leaves a zombie UI appearance covering the Squeak desktop."
		wnd fullScreenMode ifTrue: [
			self toggleFullScreen.
		].
		"Attempting to close or delete the containing system window from 
	 	within this menu callback causes grief; the CProjectMorph 
	 	does not like to be dismantled from within itself."
		WorldState addDeferredUIMessage:(MessageSend
			receiver: wnd window selector: #closeBoxHit).
		WorldState addDeferredUIMessage:(MessageSend
			receiver: World selector: #restoreMorphicDisplay).
	].

! !

!CProjectBuilder methodsFor: 'initialize' stamp: 'sw 2/8/2005 03:10'!
rebuildPartsLibrary
	"Rebuild the parts library from scratch"

	Smalltalk at: #CPartsBin ifPresent: [:pbClass | pbClass rebuildPartsLibrary]! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 10/20/2003 19:50'!
refreshDisplay
	self invalidate.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 3/26/2004 21:19'!
resize: aPlayer by: delta
	| oldValue newValue parent |
	oldValue := aPlayer extent.
	parent := aPlayer container.
	parent gridEnabled 
		ifTrue:[newValue := oldValue + (delta * parent grid extent)]
		ifFalse:[newValue := oldValue + delta].
	aPlayer extent: newValue.
	aPlayer tweaked: #extent from: oldValue to: newValue.! !

!CProjectBuilder methodsFor: 'display' stamp: 'ar 10/20/2003 19:50'!
restoreCursor
	self hand mouseCursor: Cursor normal.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'tk 7/14/2004 11:28'!
rotateHaloTarget: aTarget from: lastPt to: nextPt center: centerPt 
	| dir1 dir2 deg sign |
	lastPt = nextPt ifTrue:[^self].
	dir1 := lastPt - centerPt.
	dir2 := nextPt - centerPt.
	dir1 isZero ifTrue:[^self].
	dir2 isZero ifTrue:[^self].
	dir1 := dir1 normalized.
	dir2 := dir2 normalized.
	sign := (dir1 crossProduct: dir2) sign.
	deg := (dir1 dotProduct: dir2) arcCos radiansToDegrees.
	aTarget asPrimCostume rotateBy: deg*sign.! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 2/27/2004 18:46'!
saveCostume: aCostume for: aPlayer
	| maker |
	"This doesn't work properly yet"
	aPlayer player ifNotNil:[self halt: 'Check this'].
	maker := CTweakMaker newFrom: aCostume.
	maker allImportsDo:[:each|
		each isBehavior ifFalse:[self error:'Cannot deal with this yet'].
		each isUniClass ifTrue:[self error: 'Cannot deal with this yet'].
	].
	self halt.
! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 11/24/2004 08:51'!
saveImage
	"Save the image"
	Smalltalk snapshot: true andQuit: false.
	self world invalidate.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 7/15/2005 23:58'!
saveImageAs
	"Save the image"
	| fileName |
	fileName := CFileSaveDialog openFile: #(
			('Image files'	('*.image'))
		) label: 'Save Image As...'.
	fileName ifNil:[^false].
	Smalltalk saveAs: fileName.
	self world invalidate.! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 5/22/2005 19:02'!
saveObject
	| obj fileName |
	obj := self halo target.
	obj ifNil:[^Smalltalk beep].
	fileName := CFileSaveDialog openFile: #(
			('Player files'	('*.sqp'))
		) label: 'Save Player'.
	fileName ifNil:[^self].
	Smalltalk beep.! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 5/29/2005 19:08'!
saveProject
	"Save the current project"
	| fileName file sema |
	projectShell fileName ifNil:[^self saveProjectAs].
	self waitTick.
	Preferences profileProjectWriting ifTrue:[
		sema := Semaphore new.
		self startScript:[MessageTally spyOnScript:[sema wait]].
		self waitTick.
	].
	[
		"Save the project"
		fileName := projectShell fileName.
		file := FileStream forceNewFileNamed: fileName.
		[projectShell saveProjectOn: file] ensure:[file close].

		"For testing - reload the project immediately"
		projectShell closeProject.
		file := FileStream readOnlyFileNamed: fileName.
		[projectShell readProjectFrom: file] ensure:[file close].

	] ensure:[
		sema ifNotNil:[sema signal].
	].
	^true! !

!CProjectBuilder methodsFor: 'project' stamp: 'ar 5/28/2005 18:12'!
saveProjectAs
	"Save the current project"
	| fileName |
	fileName := CFileSaveDialog openFile: #(
			('Project files'	('*.prj'))
		) label: 'Save Project'.
	fileName ifNil:[^false].
	projectShell fileName: fileName.
	window ifNotNil:[window label: fileName].
	^self saveProject.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 3/25/2004 18:54'!
saveToFile: aPlayer
	| fileName |
	fileName := CFileSaveDialog openFile: #(
			('Player files'	('*.sqp'))
		) label: 'Save Player'.
	fileName ifNil:[^self].
	Smalltalk beep.! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 4/2/2004 15:01'!
sendToBack: target
	target container addFirst: target! !

!CProjectBuilder methodsFor: 'halo-menu' stamp: 'ar 4/2/2004 15:00'!
sendToFront: target
	target container add: target! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 6/5/2005 12:15'!
setBackgroundPicture
	"Open a file"
	| fileName file object pictureTypes allTypes dialog |
	pictureTypes := #('*.gif' '*.jpg' '*.bmp' '*.png' '*.jpeg').
	allTypes := pictureTypes.
	dialog := CFileOpenDialog new.
	dialog directory: (lastImportDirectory ifNil:[FileDirectory default]).
	fileName := dialog openFile: {
		{'Pictures'. pictureTypes}.
	} label: 'Choose background picture'.
	fileName ifNil:[^self].
	lastImportDirectory := dialog directory.
	file := FileStream readOnlyFileNamed: fileName.
	[object := Processor activeProject importImageFrom: file] ensure:[file close].
	object ifNotNil:[self graphic: object graphic].
! !

!CProjectBuilder methodsFor: 'initialize' stamp: 'ar 12/14/2009 19:15'!
setupCostume
	super setupCostume.
	extent := 800@600.

	self clipping: true.

	self add: projectList.
	projectList visible: false.
	projectList color: CWidgetLibrary default paneColor.
	projectList width: 110.
	projectList borderStyle: #simple.
	projectList borderWidth: 1.
	projectList borderColor: (CWidgetLibrary default frameColor).

	projectShell ifNotNil:[
		projectShell borderStyle: #simple.
		projectShell borderWidth: 1.
		projectShell borderColor: (CWidgetLibrary default frameColor).
		self add: projectShell.
	].

	self add: worldMenu.

	self startScript: #showInitialStuff.! !

!CProjectBuilder methodsFor: 'initialize' stamp: 'ar 5/28/2005 23:40'!
showInitialStuff
	self waitTick; waitTick.
	self showLicense window moveBy: -10@-40.
	self showReleaseNotes window moveBy: 10@40.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 5/28/2005 23:35'!
showLicense
	| ws |
	ws := projectShell myIsland new: CWorkspace.
	"tricky... need to create text in project's island"
	ws contents: (ws send: #licenseText to: self class).
	ws extent: 500@400.
	self waitTick.
	ws openCenteredIn: projectShell projectWorld.
	ws label: 'License'.
	^ws! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 10/17/2004 17:34'!
showProjectList: aBool
	| item |
	projectList visible: aBool.
	item := (worldMenu itemNamed: 'Options') subMenu itemNamed: 'Show project list'.
	item checked: aBool! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 8/5/2005 17:58'!
showProjectNavigator
	| navigator |
	navigator := CProjectNavigator new.
	navigator projectList: allProjects.
	projectShell add: navigator.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 5/28/2005 23:35'!
showReleaseNotes
	| ws |
	ws := projectShell myIsland new: CWorkspace.
	"tricky... need to create text in project's island"
	ws contents: (ws send: #tcarReleaseNotes to: self class).
	ws extent: 500@400.
	ws openCenteredIn: projectShell projectWorld.
	ws label: 'Release Notes'.
	^ws! !

!CProjectBuilder methodsFor: 'tools' stamp: 'ar 5/28/2005 22:28'!
showTrashCan
	"Show the trash can"
	| mgr |
	mgr := projectShell myProject trashManager.
	mgr assureTrashCanShows.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 3/25/2004 21:44'!
startMessageTally
	(self confirm: 'MessageTally will start now,
and stop when the cursor goes
to the top of the screen') ifFalse:[^nil].
	MessageTally spyOnScript:[
		[hand position y > 0] whileTrue:[self wait: 0.1]
	].! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 12/18/2004 19:46'!
toggleFullScreen
	"Toggle fullscreen mode"
	Tweak fullScreenMode: Tweak fullScreenMode not.
	window ifNotNil:[window fullScreenMode: Tweak fullScreenMode].! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 10/17/2004 17:35'!
toggleProjectList
	self showProjectList: projectList visible not.! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 12/13/2004 20:45'!
toggleWorldMenu
	self automaticWorldMenu: self automaticWorldMenu not.! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/29/2004 16:50'!
toolMenuItems
	^self class toolMenuItems! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 8/5/2005 15:02'!
toolsMenu
	| menu |
	menu := CMenu new.
	menu add: 'Painting' target: self action: #makeNewDrawing.
	menu add: 'Trash can' target: self action: #showTrashCan.
	menu add: 'Project navigator' target: self action: #showProjectNavigator.
	menu addSeparator.
	toolMenuItems do:[:each|
		menu add: each label target: self action: #openTool: arguments:{each action}.
	].
	^menu! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 6/25/2005 17:47'!
trackHaloHandle: aHandle in: aBlock
	"Track the given handle so that we can drag it"
	| cursor lastPos nextPos |
	lastPos := aHandle container localToWorld: aHandle origin.
	aHandle world add: aHandle.
	aHandle topLeft: lastPos.
	self halo elements do:[:each| each visible: false].
	cursor := self hand mouseCursor.
	self hand mouseCursor: cursor asForm.
	lastPos := self hand position.
	aBlock value.
	aHandle forEach: #mouseMove do:[
		nextPos := self hand position.
		aHandle costume moveBy: nextPos - lastPos.
		lastPos := nextPos.
		aBlock value.
	] until: #mouseUp.
	aBlock value.
	"Restore halo after interaction completed"
	self halo add: aHandle.
	self halo elements do:[:each| each visible: true].
	self hand mouseCursor: cursor.
	self halo onTargetFrameChanged.
! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 6/27/2005 15:10'!
turn: anObject by: delta
	| oldValue newValue |
	oldValue := anObject rotation.
	newValue := oldValue + delta.
	anObject rotation: newValue.
	anObject tweaked: #rotation from: oldValue to: newValue.! !

!CProjectBuilder methodsFor: 'updates' stamp: 'ar 5/27/2005 20:42'!
updateFromRepositories
	| map count |
	count := 0.
	[map := self defaultConfiguration.
	map log: MCConfiguration defaultLog.
	[map updateFromRepositories.
	count := count + map upgrade] ensure:[map log: nil].
	DefaultConfiguration == nil] whileTrue. "repeat if we have a new map"
	^count printString, ' packages updated'! !

!CProjectBuilder methodsFor: 'menu' stamp: 'ar 3/13/2004 17:11'!
vmStatistics
	| ws |
	ws := CWorkspace open.
	ws codePane contents: Utilities vmStatisticsReportString.! !

!CProjectBuilder methodsFor: 'halo' stamp: 'ar 1/7/2004 23:04'!
waitHaloAction: aHandle
	"Wait for a halo 'button action' to fire or abort"
	| evt |
	evt := self waitUntilAnyOf: {
		aHandle. #fire.
		aHandle. #abortFire.
	}.
	^evt selector == #fire! !

!CProjectBuilder methodsFor: 'menu' stamp: 'tak 5/26/2005 17:36'!
widgetsMenu
	| menu string label group subMenu |
	menu := CMenu new.
	{
		'Basic' -> {
			CRectanglePlayer.
			CRoundRectPlayer.
			CEllipsePlayer.
			CPolygonPlayer.
		}.
		'Buttons' -> {
			CPushButton.
			CRadioButton.
			CImageButton.
			CCheckBox.
			CTabButton.
		}.
		'Text' -> {
			CLabel.
			CTextEditor.
			CInputField.
		}.
		'Lists' -> {
			CList.
			CPopUpList.
			CDropDownList.
			CSpinnerList.
			CStringList.
		}.
		'Scrolling' -> {
			CSlider.
			CScrollBar.
			CScrollPane.
			CSpinnerButtons.
			CSpinner.
			CWheelWidget.
		}.
		'Windows' -> {
			CWindow.
			CUserDialog.
			CFileOpenDialog.
			CFileSaveDialog.
		}.
	} do:[:assoc|
		label := assoc key.
		group := assoc value.
		subMenu := CMenu new.
		group do:[:each| 
			string := each name allButFirst.
			(string endsWith: 'Player') ifTrue:[string := string allButLast: 6].
			subMenu 
				add: string translated
				target: self 
				action: #openWidget: 
				argument: each].
		menu add: label translated subMenu: subMenu. 
	].
	^menu! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:13'!
window
	"This method was automatically generated"
	<bewareOf: #windowChanged>
	^self propertyValueAt: #window! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:24'!
window: aValue
	"This method was automatically generated"
	^self propertyValueAt: #window put: aValue with: #windowChanged! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:13'!
worldMenu
	"This method was automatically generated"
	<bewareOf: #worldMenuChanged>
	^self propertyValueAt: #worldMenu! !

!CProjectBuilder methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:24'!
worldMenu: aValue
	"This method was automatically generated"
	^self propertyValueAt: #worldMenu put: aValue with: #worldMenuChanged! !

CPlayer subclass: #CProjectCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder-Costumes'!

CProjectCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="image" toSet="image:" changeEvent="imageChanged">image</field>
</fields>'!

!CProjectCostume methodsFor: 'initialize' stamp: 'ar 3/23/2004 21:54'!
deselect
	dropShadow active: true.! !

!CProjectCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:26'!
image
	"Answer the image of the receiver"
	<bewareOf: #imageChanged>
	^self propertyValueAt: #image! !

!CProjectCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:26'!
image: aValue
	"Modify the receiver's image"
	^self propertyValueAt: #image put: aValue with: #imageChanged! !

!CProjectCostume methodsFor: 'initialize' stamp: 'ar 3/22/2004 14:41'!
initialize
	super initialize.
	self define: #image as: CPlayer new.
	self define: #label as: CLabel new.
! !

!CProjectCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:25'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CProjectCostume methodsFor: 'accessing' stamp: 'ar 3/12/2004 16:25'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CProjectCostume methodsFor: 'private' stamp: 'ar 2/6/2005 23:45'!
listItemValue: aValue
	"See comment in listItemValue:"
	^self player: aValue! !

!CProjectCostume methodsFor: 'events' stamp: 'ar 2/6/2005 21:51'!
onNameChanged
	<on: nameChanged in: player>
	label value: player name.
	balloonHelp := 'Click here to enter ', player name storeString.! !

!CProjectCostume methodsFor: 'events' stamp: 'ar 3/17/2004 17:34'!
onPlayerChanged
	<on: playerChanged>
	player ifNil:[^self].
	self onNameChanged.
	self onThumbnailChanged.! !

!CProjectCostume methodsFor: 'events' stamp: 'ar 3/25/2004 21:52'!
onThumbnailChanged
	<on: thumbnailChanged in: player>
	image graphic: player thumbnail.! !

!CProjectCostume methodsFor: 'initialize' stamp: 'ar 3/23/2004 21:54'!
select
	dropShadow active: false.! !

!CProjectCostume methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:58'!
setupCostume
	self add: image.
	self add: label.
	self dropShadowEnabled: true.
	image graphicEnabled: true.
	image graphicFit: #scale.
	image clipping: true.
	self layout: CTableLayout new.
	self color: (Color gray: 0.9).
	self borderStyle: #simple.
	self borderWidth: 1.
	self borderColor: Color black.
	self roundCorners: true.
	self extent: 80@60.
! !

CPlayer subclass: #CProjectListCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder-Costumes'!

CProjectListCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="image" toSet="image:" changeEvent="imageChanged">image</field>
</fields>'!

!CProjectListCostume methodsFor: 'selecting' stamp: 'jrd 10/17/2008 19:21'!
deselect
	color := Color transparent.
	label textColor: CWidgetLibrary default normalTextColor! !

!CProjectListCostume methodsFor: 'accessing' stamp: 'ar 2/6/2005 23:41'!
image
	"Answer the image of the receiver"
	<bewareOf: #imageChanged>
	^self propertyValueAt: #image! !

!CProjectListCostume methodsFor: 'accessing' stamp: 'ar 2/6/2005 23:41'!
image: aValue
	"Modify the receiver's image"
	^self propertyValueAt: #image put: aValue with: #imageChanged! !

!CProjectListCostume methodsFor: 'initialize' stamp: 'ar 2/6/2005 23:42'!
initialize
	super initialize.
	self define: #image as: CPlayer new.
	self define: #label as: CLabel new.! !

!CProjectListCostume methodsFor: 'accessing' stamp: 'ar 2/6/2005 23:41'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CProjectListCostume methodsFor: 'accessing' stamp: 'ar 2/6/2005 23:41'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CProjectListCostume methodsFor: 'private' stamp: 'ar 2/6/2005 23:45'!
listItemValue: aValue
	"See comment in listItemValue:"
	^self player: aValue! !

!CProjectListCostume methodsFor: 'events' stamp: 'ar 2/6/2005 23:41'!
onNameChanged
	<on: nameChanged in: player>
	label value: player name.
	balloonHelp := 'Click here to enter ', player name storeString.! !

!CProjectListCostume methodsFor: 'events' stamp: 'ar 2/6/2005 23:41'!
onPlayerChanged
	<on: playerChanged>
	player ifNil:[^self].
	self onNameChanged.
	self onThumbnailChanged.! !

!CProjectListCostume methodsFor: 'events' stamp: 'ar 2/6/2005 23:41'!
onThumbnailChanged
	<on: thumbnailChanged in: player>
	image graphic: player thumbnail.! !

!CProjectListCostume methodsFor: 'selecting' stamp: 'jrd 10/17/2008 19:21'!
select
	color := container selectionColor.
	label textColor:  CWidgetLibrary default selectedTextColor.! !

!CProjectListCostume methodsFor: 'initialize' stamp: 'ar 2/6/2005 23:48'!
setupCostume
	self add: image.
	self add: label.
	image graphicEnabled: true.
	image graphicFit: #scale.
	image clipping: true.
	image extent: 24@24.
	image color: (Color gray: 0.9).
	self layoutInset: 2@2.
	self layout: CTableLayout new.
	self layout listDirection: #leftToRight.
	self hResizing: #spaceFill.
	self vResizing: #shrinkFit.
! !

Object subclass: #CProjectLoader
	instanceVariableNames: 'archive resources notifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder'!

!CProjectLoader class methodsFor: 'instance creation' stamp: 'ar 12/2/2003 19:28'!
readFrom: aStream
	^self new readFrom: aStream! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 12/2/2003 21:47'!
importClass: xmlNode
	| id |
	id := xmlNode attributeAt: 'id'.
	^Smalltalk at: id asSymbol! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 12/2/2003 21:49'!
importFont: xmlNode
	| fontName fontSize fontEmphasis font |
	fontName := xmlNode attributeAt: 'name'.
	fontSize := xmlNode literalAt: 'size'.
	fontEmphasis := xmlNode literalAt: 'emphasis'.
	font := StrikeFont familyName: fontName size: fontSize emphasized: fontEmphasis.
	font resourceID = (xmlNode attributeAt: 'id') ifFalse:[self error: 'oops?'].
	^font! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 3/14/2004 17:27'!
importForm: xmlNode
	| uid aForm formClass w h d |
	uid := UUID fromString: (xmlNode attributeAt: 'id').
	aForm := CResourceManager default lookup: uid ifAbsent:[nil].
	aForm ifNotNil:[^aForm].
	formClass := Smalltalk at: (xmlNode attributeAt: 'class') asSymbol.
	w := xmlNode literalAt: 'width'.
	h := xmlNode literalAt: 'height'.
	d := xmlNode literalAt: 'depth'.
	aForm := CImageResource with: (formClass extent: w@h depth: d).
	aForm name: (xmlNode attributeAt: 'name').
	aForm type: (xmlNode attributeAt: 'type').
	aForm url: (xmlNode attributeAt: 'url').
	CResourceManager default at: uid put: aForm.
	aForm extractResourceFrom: archive in: self.
	^aForm! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 3/25/2004 19:22'!
importLibrary: xmlNode
	| id maker fileName mbr lib resID |
	id := UUID fromString: (resID := xmlNode attributeAt: 'id').
	resources at: resID put: (lib := CProjectLibrary new).
	fileName := 'resources/library/', id asString,'/library.maker'.
	mbr := archive members detect:[:any| any fileName = fileName].
	maker := CObjectMaker new.
	maker readFrom: mbr contentStream in: self.
	lib updateFrom: maker next.
	^lib! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 12/3/2003 00:45'!
importObjectMaker: xmlNode
	| id maker |
	id := UUID fromString: (xmlNode attributeAt: 'id').
	maker := CMaker withID: id.
	maker ifNotNil:[^maker].
	maker := CObjectMaker new.
	maker uuid: id.
	^maker extractResourceFrom: archive in: self.! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 6/1/2005 11:38'!
importScripted: xmlNode
	| id baseClass uniClass |
	id := UUID fromString: (xmlNode attributeAt: 'id').
	baseClass := Smalltalk at: (xmlNode attributeAt: 'extends') asSymbol.
	uniClass := baseClass findUniClass: id.
	uniClass ifNotNil:[^uniClass].
	uniClass := baseClass newUniClass.
	uniClass classVersionID: id.
	^uniClass extractResourceFrom: archive in: self! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 12/3/2003 00:27'!
loadResource: resID type: resType xmlNode: node
	| provider resource |
	resource := resources at: resID ifAbsent:[nil].
	resource ifNotNil:[^resource].
	notifier value: 'Loading ', ((node attributeAt: 'name') ifNil:['a ', resType, '(', resID,')']).
	provider := CResource resourceProviderFor: resType.
	resource := provider importXmlResource: node in: self.
	resources at: resID put: resource.
	^resource! !

!CProjectLoader methodsFor: 'interface' stamp: 'ar 12/7/2003 17:44'!
readFrom: aStream notifying: bar
	| member version projMaker |
	"Check the version"
	version := aStream next: 9.
	version = 'Tweak-1.0' ifFalse:[^self error: 'Wrong version: ', version].

	notifier := bar.
	resources := Dictionary new.
	archive := ZipArchive new.
	archive readFrom: aStream.

	"Load the contents of the project"
	bar value: 'Loading project...'.
	member := archive memberNamed: 'contents.maker'.
	projMaker := CObjectMaker new readFrom: member contentStream in: self.
	^projMaker next! !

!CProjectLoader methodsFor: 'import' stamp: 'ar 12/2/2003 20:45'!
registerResource: aResource id: resID
	resources at: resID put: aResource! !

!CProject2 methodsFor: '*Tweak-ProjectBuilder' stamp: 'ar 7/8/2007 13:16'!
dropFile: fileStream
	"The given file was just dropped onto me"
	| types |
	types := fileStream mimeTypes ifNil:[#()].
	(types anySatisfy:[:mimeType| mimeType beginsWith: 'image/']) ifTrue:[
		(self importImageFrom: fileStream) asPlayer openIn: world at: world cursorPoint.
	] ifFalse:[
		UIManager default edit: fileStream contents label: fileStream localName
	].! !

!CProject2 methodsFor: '*Tweak-ProjectBuilder' stamp: 'ar 6/5/2005 12:09'!
importImageFrom: aFile
	| object aGraphic |
	aFile binary.
	Cursor read showWhile:[aGraphic := CImageResource readFrom: aFile].
	object := CImagePlayer new.
	object value: aGraphic.
	object graphicForm: aGraphic.
	object graphicFit: #stretch.
	object extent: aGraphic extent.
	object fill: nil.
	object name: (aFile localName readStream upTo: $. ).
	^object! !

!CProject2 methodsFor: '*Tweak-ProjectBuilder' stamp: 'ar 6/5/2005 12:11'!
importMovieFrom: file
	| aSound object |
	file binary.
	Cursor read showWhile:[aSound := CMovieResource readFrom: file].
	object := CSoundPlayer new.
	object value: aSound.
	object name: (file localName readStream upTo: $. ).
	^object! !

!CProject2 methodsFor: '*Tweak-ProjectBuilder' stamp: 'ar 6/5/2005 12:10'!
importSoundFrom: file
	| aSound object |
	file binary.
	Cursor read showWhile:[aSound := CSoundResource readFrom: file].
	object := CSoundPlayer new.
	object value: aSound.
	object name: (file localName readStream upTo: $. ).
	^object! !

CObject subclass: #CLibraryEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder'!

CLibraryEntry defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="image" toSet="image:" changeEvent="imageChanged">image</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="library" toSet="library:" changeEvent="libraryChanged">library</field>
</fields>'!

!CLibraryEntry methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:09'!
image
	"This method was automatically generated"
	<bewareOf: #imageChanged>
	^self propertyValueAt: #image! !

!CLibraryEntry methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:22'!
image: aValue
	"This method was automatically generated"
	^self propertyValueAt: #image put: aValue with: #imageChanged! !

!CLibraryEntry methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:09'!
label
	"This method was automatically generated"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CLibraryEntry methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:22'!
label: aValue
	"This method was automatically generated"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CLibraryEntry methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:10'!
library
	"This method was automatically generated"
	<bewareOf: #libraryChanged>
	^self propertyValueAt: #library! !

!CLibraryEntry methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:22'!
library: aValue
	"This method was automatically generated"
	^self propertyValueAt: #library put: aValue with: #libraryChanged! !

!CLibraryEntry methodsFor: 'maker' stamp: 'ar 3/14/2004 15:18'!
next
	^value next! !

CObject subclass: #CProjectLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-ProjectBuilder'!

CProjectLibrary defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
</fields>'!

!CProjectLibrary methodsFor: 'lookup' stamp: 'ar 3/15/2004 20:52'!
bindingOf: varName
	^self componentNamed: varName! !

!CProjectLibrary methodsFor: 'accessing' stamp: 'ar 3/17/2004 15:09'!
contents
	"This method was automatically generated"
	<bewareOf: #contentsChanged>
	^self propertyValueAt: #contents! !

!CProjectLibrary methodsFor: 'accessing' stamp: 'ar 3/11/2004 14:22'!
contents: aValue
	"This method was automatically generated"
	^self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!CProjectLibrary methodsFor: 'initialize' stamp: 'ar 3/17/2004 03:12'!
initialize
	super initialize.
	self define: #contents as: CCollection new.! !

!CProjectLibrary methodsFor: 'saving' stamp: 'ar 3/15/2004 03:05'!
save: aPlayer
	^ self save: aPlayer thumbnail: nil! !

!CProjectLibrary methodsFor: 'saving' stamp: 'ar 3/25/2004 19:23'!
save: anObject as: makerName thumbnail: thumb
	"Save the object under the given name, overwriting any present entry."
	| newEntry binding oldEntry newMaker oldMaker newObject |
	newMaker := CObjectMaker newFrom: anObject.
	newMaker name: makerName.
	"For now, try to capture any problems early on..."
	newObject := newMaker next.
	newObject isPlayer ifTrue:[
		[newObject layoutNeeded] whileTrue:[
			newObject fullBounds.
			self waitTick]].

	binding := self bindingOf: makerName.
	binding ifNil:[
		self define: makerName as: newMaker.
		newMaker saveTemp.
	] ifNotNil:[
		oldMaker := binding value.
		oldMaker saveTemp.
		newMaker saveTemp.
		[binding value: newMaker] 
			on: AttemptToWriteReadOnlyGlobal 
			do:[:ex| ex resume: true].
		oldEntry := self contents detect:[:any| any itemFactory == oldMaker] ifNone:[nil].
	].

	newEntry := CLibraryEntry new.
	newEntry value: newMaker.
	newEntry image: (thumb ifNil:[newObject asForm]).
	newEntry label: makerName.
	newEntry library: self.
	self contents replace: oldEntry with: newEntry.! !

!CProjectLibrary methodsFor: 'saving' stamp: 'ar 1/5/2005 18:05'!
save: aPlayer thumbnail: thumb
	"Save aPlayer, overwriting any existing factory if it already exists"
	| baseName existing makerName |
	baseName := aPlayer name stemAndNumericSuffix first.
	makerName := baseName,'Maker'.
	"Look if the binding for the player already exists"
	existing := self bindingOf: makerName.
	existing ifNotNil:[
		"We allow silently overwriting an existing entry if the new player came from the same maker (e.g., we just modified it). If it was created by a different maker, ask the user first, so not to accidentally overwrite some older entry."
		aPlayer maker = existing value ifFalse:[
			(self confirm: 'Overwrite ''', baseName,'''?')
				ifFalse:[^self].
		].
	].
	^self save: aPlayer as: makerName thumbnail: thumb! !
CProjectBuilder initialize!
